<?php

/**
 * @author Ihsana Team <imabuilder@ihsana.com>
 * @copyright Ihsana IT Solution 2021
 * @license Commercial License
 * 
 * @package `multiple-choice-question`
 */
defined('JSM_EXEC') or die('Silence is golden');
$is_debug = false;
$prefix_addons = 'multiple-choice-question';
// init class
$db = new jsmDatabase();
$current_app = $db->current();
$static_pages = $db->getStaticPages();
$addons_settings = $db->getAddonsUsed("multiple-choice-question");
$string = new jsmString();
if (!isset($_GET['page-target']))
{
    $_GET['page-target'] = '';
}
$current_page_target = $string->toFileName($_GET['page-target']);
if ($_GET['a'] === 'delete')
{
    $db->deleteAddOns('multiple-choice-question', $current_page_target);
    header('Location: ./?p=addons&addons=multiple-choice-question&' . time());
}
//TODO: ===============================================================
// TODO: POST
if (isset($_POST['save-multiple-choice-question']))
{


    // save addons setting
    $addons = array();
    $addons['page-target'] = $current_page_target;

    // TODO: POST --|-- RESPONSE
    $addons['page-title'] = trim($_POST[$prefix_addons]['page-title']);
    $addons['page-header-color'] = trim($_POST[$prefix_addons]['page-header-color']);
    $addons['page-content-background'] = trim($_POST[$prefix_addons]['page-content-background']);

    //backend-used
    $addons['backend-used'] = trim($_POST[$prefix_addons]['backend-used']); //select
    //api-url
    if (!isset($_POST[$prefix_addons]['api-url']))
    {
        $_POST[$prefix_addons]['api-url'] = '';
    }
    $addons['api-url'] = trim($_POST[$prefix_addons]['api-url']); //text
    //multiple-language
    // checkbox
    if (isset($_POST[$prefix_addons]['multiple-language']))
    {
        $addons['multiple-language'] = true;
    } else
    {
        $addons['multiple-language'] = false;
    }

    //show-answers-and-scores
    // checkbox
    if (isset($_POST[$prefix_addons]['show-answers-and-scores']))
    {
        $addons['show-answers-and-scores'] = true;
    } else
    {
        $addons['show-answers-and-scores'] = false;
    }

    //only-one-chance
    // checkbox
    if (isset($_POST[$prefix_addons]['only-one-chance']))
    {
        $addons['only-one-chance'] = true;
    } else
    {
        $addons['only-one-chance'] = false;
    }


    // TODO: POST --|-- RESPONSE --|-- LABELS
    //label-for-please-wait
    if (!isset($_POST[$prefix_addons]['label-for-please-wait']))
    {
        $_POST[$prefix_addons]['label-for-please-wait'] = 'Please wait...!';
    }
    $addons['label-for-please-wait'] = trim($_POST[$prefix_addons]['label-for-please-wait']); //text


    //label-for-ok
    if (!isset($_POST[$prefix_addons]['label-for-ok']))
    {
        $_POST[$prefix_addons]['label-for-ok'] = 'OK';
    }
    $addons['label-for-ok'] = trim($_POST[$prefix_addons]['label-for-ok']); //text
    //label-for-connection-lost
    if (!isset($_POST[$prefix_addons]['label-for-connection-lost']))
    {
        $_POST[$prefix_addons]['label-for-connection-lost'] = 'Connection lost, please check your connection!';
    }
    $addons['label-for-connection-lost'] = trim($_POST[$prefix_addons]['label-for-connection-lost']); //text
    //label-for-question
    if (!isset($_POST[$prefix_addons]['label-for-question']))
    {
        $_POST[$prefix_addons]['label-for-question'] = 'Question';
    }
    $addons['label-for-question'] = trim($_POST[$prefix_addons]['label-for-question']); //text
    //label-for-your-choice
    if (!isset($_POST[$prefix_addons]['label-for-your-choice']))
    {
        $_POST[$prefix_addons]['label-for-your-choice'] = 'Your choice...!';
    }
    $addons['label-for-your-choice'] = trim($_POST[$prefix_addons]['label-for-your-choice']); //text


    //label-for-your-answer-is-wrong
    if (!isset($_POST[$prefix_addons]['label-for-your-answer-is-wrong']))
    {
        $_POST[$prefix_addons]['label-for-your-answer-is-wrong'] = 'Your answer is wrong!';
    }
    $addons['label-for-your-answer-is-wrong'] = trim($_POST[$prefix_addons]['label-for-your-answer-is-wrong']); //text

    //label-for-your-answer-is-correct
    if (!isset($_POST[$prefix_addons]['label-for-your-answer-is-correct']))
    {
        $_POST[$prefix_addons]['label-for-your-answer-is-correct'] = 'Your answer is correct!';
    }
    $addons['label-for-your-answer-is-correct'] = trim($_POST[$prefix_addons]['label-for-your-answer-is-correct']); //text

    //label-for-sure-i-agree
    if (!isset($_POST[$prefix_addons]['label-for-sure-i-agree']))
    {
        $_POST[$prefix_addons]['label-for-sure-i-agree'] = 'Sure, I agree';
    }
    $addons['label-for-sure-i-agree'] = trim($_POST[$prefix_addons]['label-for-sure-i-agree']); //text

    //label-for-update
    if (!isset($_POST[$prefix_addons]['label-for-update']))
    {
        $_POST[$prefix_addons]['label-for-update'] = '';
    }
    $addons['label-for-update'] = trim($_POST[$prefix_addons]['label-for-update']); //text

    //label-for-score
    if (!isset($_POST[$prefix_addons]['label-for-score']))
    {
        $_POST[$prefix_addons]['label-for-score'] = 'Score';
    }
    $addons['label-for-score'] = trim($_POST[$prefix_addons]['label-for-score']); //text

    //label-for-the-correct-answer-is
    if (!isset($_POST[$prefix_addons]['label-for-the-correct-answer-is']))
    {
        $_POST[$prefix_addons]['label-for-the-correct-answer-is'] = 'The correct answer is';
    }
    $addons['label-for-the-correct-answer-is'] = trim($_POST[$prefix_addons]['label-for-the-correct-answer-is']); //text

    //label-for-update-the-question
    if (!isset($_POST[$prefix_addons]['label-for-update-the-question']))
    {
        $_POST[$prefix_addons]['label-for-update-the-question'] = 'Are you sure you want to update the question data? ';
    }
    $addons['label-for-update-the-question'] = trim($_POST[$prefix_addons]['label-for-update-the-question']); //text

    //label-for-cancel
    if (!isset($_POST[$prefix_addons]['label-for-cancel']))
    {
        $_POST[$prefix_addons]['label-for-cancel'] = 'Cancel';
    }
    $addons['label-for-cancel'] = trim($_POST[$prefix_addons]['label-for-cancel']); //text


    //label-for-attention
    if (!isset($_POST[$prefix_addons]['label-for-attention']))
    {
        $_POST[$prefix_addons]['label-for-attention'] = 'Attention!';
    }
    $addons['label-for-attention'] = trim($_POST[$prefix_addons]['label-for-attention']); //text


    //label-for-question-run-out
    if (!isset($_POST[$prefix_addons]['label-for-question-run-out']))
    {
        $_POST[$prefix_addons]['label-for-question-run-out'] = 'Question has run out';
    }
    $addons['label-for-question-run-out'] = trim($_POST[$prefix_addons]['label-for-question-run-out']); //text

    //label-for-your-score
    if (!isset($_POST[$prefix_addons]['label-for-your-score']))
    {
        $_POST[$prefix_addons]['label-for-your-score'] = 'Your score is';
    }
    $addons['label-for-your-score'] = trim($_POST[$prefix_addons]['label-for-your-score']); //text

    //label-for-repeat
    if (!isset($_POST[$prefix_addons]['label-for-repeat']))
    {
        $_POST[$prefix_addons]['label-for-repeat'] = 'Repeat';
    }
    $addons['label-for-repeat'] = trim($_POST[$prefix_addons]['label-for-repeat']); //text

    //label-for-save-score
    if (!isset($_POST[$prefix_addons]['label-for-save-score']))
    {
        $_POST[$prefix_addons]['label-for-save-score'] = 'Save Score';
    }
    $addons['label-for-save-score'] = trim($_POST[$prefix_addons]['label-for-save-score']); //text


    //label-for-submit
    if (!isset($_POST[$prefix_addons]['label-for-submit']))
    {
        $_POST[$prefix_addons]['label-for-submit'] = 'Submit';
    }
    $addons['label-for-submit'] = trim($_POST[$prefix_addons]['label-for-submit']); //text

    //label-for-personal-data
    if (!isset($_POST[$prefix_addons]['label-for-personal-data']))
    {
        $_POST[$prefix_addons]['label-for-personal-data'] = 'Personal Data';
    }
    $addons['label-for-personal-data'] = trim($_POST[$prefix_addons]['label-for-personal-data']); //text

    //label-for-name
    if (!isset($_POST[$prefix_addons]['label-for-name']))
    {
        $_POST[$prefix_addons]['label-for-name'] = 'Name';
    }
    $addons['label-for-name'] = trim($_POST[$prefix_addons]['label-for-name']); //text

    //label-for-note
    if (!isset($_POST[$prefix_addons]['label-for-note']))
    {
        $_POST[$prefix_addons]['label-for-note'] = 'Note';
    }
    $addons['label-for-note'] = trim($_POST[$prefix_addons]['label-for-note']); //text


    // TODO: POST --|-- RESPONSE --|-- SAVE
    $db->saveAddOns('multiple-choice-question', $addons);

    //TODO: ===============================================================
    // TODO: GENERATOR --|-- PROJECT --|--
    $new_project = $current_app['apps'];
    $new_project['ionic-storage'] = true;
    $db->saveProject($new_project);


    //TODO: ===============================================================
    $pipe_translate = '';
    if ($addons['multiple-language'] == true)
    {
        $pipe_translate = '| translate ';
    }
    $record_score = false;
    switch ($addons['backend-used'])
    {
        case 'php-native':
            $record_score = true;
            break;
        case 'wp-plugin':
            $record_score = true;
            break;
        case 'json-offline':
            break;
        case 'json-online':
            break;
    }


    if ($addons['multiple-language'] == true)
    {
        // TODO: LOCALIZATION
        // TODO: LOCALIZATION --|-- EN
        $localization = null;
        $localization['prefix'] = 'en';
        $localization['name'] = 'English';
        $localization['desc'] = 'Auto create by Multiple Choice Question Addons';

        $v = 0;
        $localization['words'][$v]['text'] = $addons['label-for-ok'];
        $localization['words'][$v]['translate'] = 'OK';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-please-wait'];
        $localization['words'][$v]['translate'] = 'Please wait!!!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-connection-lost'];
        $localization['words'][$v]['translate'] = 'Connection lost';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-question'];
        $localization['words'][$v]['translate'] = 'Question';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-choice'];
        $localization['words'][$v]['translate'] = 'Your choice!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-answer-is-wrong'];
        $localization['words'][$v]['translate'] = 'Your answer is wrong!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-answer-is-correct'];
        $localization['words'][$v]['translate'] = 'Your answer is correct!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-sure-i-agree'];
        $localization['words'][$v]['translate'] = 'Sure, I agree';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-update'];
        $localization['words'][$v]['translate'] = 'Update';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-score'];
        $localization['words'][$v]['translate'] = 'Score';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-the-correct-answer-is'];
        $localization['words'][$v]['translate'] = 'The correct answer is';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-update-the-question'];
        $localization['words'][$v]['translate'] = 'Are you sure you want to update the question data, this will cause your score to be zero?';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-cancel'];
        $localization['words'][$v]['translate'] = 'Cancel';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-attention'];
        $localization['words'][$v]['translate'] = 'Attention!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-question-run-out'];
        $localization['words'][$v]['translate'] = 'Question has run out!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-score'];
        $localization['words'][$v]['translate'] = 'Your score is:';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-repeat'];
        $localization['words'][$v]['translate'] = 'Repeat';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-save-score'];
        $localization['words'][$v]['translate'] = 'Save Score';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-submit'];
        $localization['words'][$v]['translate'] = 'Submit';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-personal-data'];
        $localization['words'][$v]['translate'] = 'Personal Data';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-name'];
        $localization['words'][$v]['translate'] = 'Name';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-note'];
        $localization['words'][$v]['translate'] = 'Note';


        $db->saveLocalization($localization);


        // TODO: LOCALIZATION --|-- ID
        $localization = null;
        $localization['prefix'] = 'id';
        $localization['name'] = 'Bahasa Indonesia';
        $localization['desc'] = 'Auto create by Multiple Choice Question Addons';

        $v = 0;
        $localization['words'][$v]['text'] = $addons['label-for-ok'];
        $localization['words'][$v]['translate'] = 'Baik';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-please-wait'];
        $localization['words'][$v]['translate'] = 'Silahkan tunggu!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-connection-lost'];
        $localization['words'][$v]['translate'] = 'Koneksi terputus';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-question'];
        $localization['words'][$v]['translate'] = 'Pertanyaan';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-choice'];
        $localization['words'][$v]['translate'] = 'Pilihan anda!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-answer-is-wrong'];
        $localization['words'][$v]['translate'] = 'Jawaban anda salah!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-answer-is-correct'];
        $localization['words'][$v]['translate'] = 'Jawaban anda benar!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-sure-i-agree'];
        $localization['words'][$v]['translate'] = 'Yakin, Saya yakin';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-update'];
        $localization['words'][$v]['translate'] = 'Perbarui';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-score'];
        $localization['words'][$v]['translate'] = 'Skor';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-the-correct-answer-is'];
        $localization['words'][$v]['translate'] = 'Jawaban yang benar adalah';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-update-the-question'];
        $localization['words'][$v]['translate'] = 'Apa anda yakin ingin memperbarui data pertanyaan, ini akan menyebabkan skor anda menjadi nol?';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-cancel'];
        $localization['words'][$v]['translate'] = 'Batal';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-attention'];
        $localization['words'][$v]['translate'] = 'Perhatian!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-question-run-out'];
        $localization['words'][$v]['translate'] = 'Pertanyaan telah habis!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-score'];
        $localization['words'][$v]['translate'] = 'Skor kamu adalah:';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-repeat'];
        $localization['words'][$v]['translate'] = 'Ulangi';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-save-score'];
        $localization['words'][$v]['translate'] = 'Simpan Skor';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-submit'];
        $localization['words'][$v]['translate'] = 'Kirim';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-personal-data'];
        $localization['words'][$v]['translate'] = 'Data Pribadi';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-name'];
        $localization['words'][$v]['translate'] = 'Nama';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-note'];
        $localization['words'][$v]['translate'] = 'Catatan';


        $db->saveLocalization($localization);

        // TODO: LOCALIZATION --|-- HI
        $localization = null;
        $localization['prefix'] = 'hi';
        $localization['name'] = 'Hindi';
        $localization['desc'] = 'Auto create by Multiple Choice Question Addons';

        $v = 0;
        $localization['words'][$v]['text'] = $addons['label-for-ok'];
        $localization['words'][$v]['translate'] = 'ठीक है';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-please-wait'];
        $localization['words'][$v]['translate'] = 'कृपया प्रतीक्षा करें...!!!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-connection-lost'];
        $localization['words'][$v]['translate'] = 'संपर्क टूट गया';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-question'];
        $localization['words'][$v]['translate'] = 'सवाल';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-choice'];
        $localization['words'][$v]['translate'] = 'आपकी पंसद!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-answer-is-wrong'];
        $localization['words'][$v]['translate'] = 'आपका उत्तर गलत है';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-answer-is-correct'];
        $localization['words'][$v]['translate'] = 'आपका उत्तर सही है';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-sure-i-agree'];
        $localization['words'][$v]['translate'] = 'ज़रूर, मैं सहमत हूँ';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-update'];
        $localization['words'][$v]['translate'] = 'अपडेट करें';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-score'];
        $localization['words'][$v]['translate'] = 'स्कोर';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-the-correct-answer-is'];
        $localization['words'][$v]['translate'] = 'सही उत्तर है';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-update-the-question'];
        $localization['words'][$v]['translate'] = 'क्या आप वाकई प्रश्न डेटा अपडेट करना चाहते हैं?';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-cancel'];
        $localization['words'][$v]['translate'] = 'रद्द करना';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-attention'];
        $localization['words'][$v]['translate'] = 'ध्यान!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-question-run-out'];
        $localization['words'][$v]['translate'] = 'प्रश्न समाप्त हो गया है!';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-your-score'];
        $localization['words'][$v]['translate'] = 'आपका स्कोर है:';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-repeat'];
        $localization['words'][$v]['translate'] = 'दोहराना';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-save-score'];
        $localization['words'][$v]['translate'] = 'स्कोर सहेजें';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-submit'];
        $localization['words'][$v]['translate'] = 'प्रस्तुत';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-personal-data'];
        $localization['words'][$v]['translate'] = 'व्यक्तिगत डेटा';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-name'];
        $localization['words'][$v]['translate'] = 'नाम';

        $v++;
        $localization['words'][$v]['text'] = $addons['label-for-note'];
        $localization['words'][$v]['translate'] = 'ध्यान दें';


        $db->saveLocalization($localization);


    } else
    {
        $db->deleteLocalization('en');
        $db->deleteLocalization('id');
    }

    //TODO: ===============================================================
    // TODO: GENERATOR --|-- TABLE --|-- QUESTIONS
    $newTable = null;
    $newTable['table-name'] = $current_page_target;
    $newTable['table-singular-name'] = $addons['page-title'];
    $newTable['table-plural-name'] = $addons['page-title'];
    $newTable['table-cols'] = array();
    $newTable['table-desc'] = 'List of questions';
    $newTable['table-icon-fontawesome'] = 'question-circle';
    $newTable['table-icon-dashicons'] = 'book';
    $newTable['table-icon-ionicons'] = 'quote';
    $newTable['table-variable-as-label'] = 'question_content';
    $newTable['table-variable-as-value'] = 'question_id';
    $newTable['form-filter-duplicate'] = true;
    $newTable['auth-enable'] = false;
    $newTable['form-method'] = 'none';


    $x = 0;
    $newTable['table-cols'][$x]['type'] = 'id';
    $newTable['table-cols'][$x]['label'] = 'ID';
    $newTable['table-cols'][$x]['variable'] = 'question_id';
    $newTable['table-cols'][$x]['option'] = '';
    $newTable['table-cols'][$x]['default'] = '';
    $newTable['table-cols'][$x]['info'] = '';
    $newTable['table-cols'][$x]['json-list'] = true;
    $newTable['table-cols'][$x]['json-detail'] = true;
    $newTable['table-cols'][$x]['item-list'] = true;
    $x++;
    $newTable['table-cols'][$x]['type'] = 'longtext';
    $newTable['table-cols'][$x]['label'] = 'Question';
    $newTable['table-cols'][$x]['variable'] = 'question_content';
    $newTable['table-cols'][$x]['option'] = 'Interdum Sed Duis';
    $newTable['table-cols'][$x]['default'] = '';
    $newTable['table-cols'][$x]['info'] = 'Write your question here';
    $newTable['table-cols'][$x]['json-list'] = true;
    $newTable['table-cols'][$x]['json-detail'] = true;
    $newTable['table-cols'][$x]['item-list'] = true;


    $x++;
    $newTable['table-cols'][$x]['type'] = 'varchar';
    $newTable['table-cols'][$x]['label'] = 'Choice A';
    $newTable['table-cols'][$x]['variable'] = 'choice_a';
    $newTable['table-cols'][$x]['option'] = 'Jakarta';
    $newTable['table-cols'][$x]['default'] = '';
    $newTable['table-cols'][$x]['info'] = 'Write the answer for choice A';
    $newTable['table-cols'][$x]['json-list'] = true;
    $newTable['table-cols'][$x]['json-detail'] = true;
    $newTable['table-cols'][$x]['item-list'] = true;


    $x++;
    $newTable['table-cols'][$x]['type'] = 'varchar';
    $newTable['table-cols'][$x]['label'] = 'Choice B';
    $newTable['table-cols'][$x]['variable'] = 'choice_b';
    $newTable['table-cols'][$x]['option'] = 'Surabaya';
    $newTable['table-cols'][$x]['default'] = '';
    $newTable['table-cols'][$x]['info'] = 'Write the answer for choice B';
    $newTable['table-cols'][$x]['json-list'] = true;
    $newTable['table-cols'][$x]['json-detail'] = true;
    $newTable['table-cols'][$x]['item-list'] = true;

    $x++;
    $newTable['table-cols'][$x]['type'] = 'varchar';
    $newTable['table-cols'][$x]['label'] = 'Choice C';
    $newTable['table-cols'][$x]['variable'] = 'choice_c';
    $newTable['table-cols'][$x]['option'] = 'Padang';
    $newTable['table-cols'][$x]['default'] = '';
    $newTable['table-cols'][$x]['info'] = 'Write the answer for choice C';
    $newTable['table-cols'][$x]['json-list'] = true;
    $newTable['table-cols'][$x]['json-detail'] = true;
    $newTable['table-cols'][$x]['item-list'] = true;

    $x++;
    $newTable['table-cols'][$x]['type'] = 'varchar';
    $newTable['table-cols'][$x]['label'] = 'Choice D';
    $newTable['table-cols'][$x]['variable'] = 'choice_d';
    $newTable['table-cols'][$x]['option'] = 'Papua';
    $newTable['table-cols'][$x]['default'] = '';
    $newTable['table-cols'][$x]['info'] = 'Write the answer for choice D';
    $newTable['table-cols'][$x]['json-list'] = true;
    $newTable['table-cols'][$x]['json-detail'] = true;
    $newTable['table-cols'][$x]['item-list'] = true;


    $x++;
    $newTable['table-cols'][$x]['type'] = 'varchar';
    $newTable['table-cols'][$x]['label'] = 'Choice E';
    $newTable['table-cols'][$x]['variable'] = 'choice_e';
    $newTable['table-cols'][$x]['option'] = 'Aceh';
    $newTable['table-cols'][$x]['default'] = '';
    $newTable['table-cols'][$x]['info'] = 'Write the answer for choice E';
    $newTable['table-cols'][$x]['json-list'] = true;
    $newTable['table-cols'][$x]['json-detail'] = true;
    $newTable['table-cols'][$x]['item-list'] = true;

    $x++;
    $newTable['table-cols'][$x]['type'] = 'select';
    $newTable['table-cols'][$x]['label'] = 'Correct Answer';
    $newTable['table-cols'][$x]['variable'] = 'correct_answer';
    $newTable['table-cols'][$x]['option'] = 'A|B|C|D|E';
    $newTable['table-cols'][$x]['default'] = 'A';
    $newTable['table-cols'][$x]['info'] = 'The correct choice is in the choice? ';
    $newTable['table-cols'][$x]['json-list'] = true;
    $newTable['table-cols'][$x]['json-detail'] = true;
    $newTable['table-cols'][$x]['item-list'] = true;

    $x++;
    $newTable['table-cols'][$x]['type'] = 'image';
    $newTable['table-cols'][$x]['label'] = 'Additional Image';
    $newTable['table-cols'][$x]['variable'] = 'question_image';
    $newTable['table-cols'][$x]['option'] = 'https://yourhosting/image.jpg';
    $newTable['table-cols'][$x]['default'] = '';
    $newTable['table-cols'][$x]['info'] = 'Add image if needed';
    $newTable['table-cols'][$x]['json-list'] = true;
    $newTable['table-cols'][$x]['json-detail'] = true;
    $newTable['table-cols'][$x]['item-list'] = true;


    switch ($addons['backend-used'])
    {
        case 'php-native':
            $x++;
            break;
        case 'wp-generator':
            break;
    }
    $db->saveTable($newTable);

    if ($record_score == true)
    {

        // TODO: GENERATOR --|-- TABLE --|-- SCORE
        $newTable = null;
        $newTable['table-name'] = 'sc-' . $current_page_target;
        $newTable['table-singular-name'] = 'Score for ' . $addons['page-title'];
        $newTable['table-plural-name'] = 'Score for ' . $addons['page-title'];
        $newTable['table-cols'] = array();
        $newTable['table-desc'] = 'List of Scores';
        $newTable['table-icon-fontawesome'] = 'trophy';
        $newTable['table-icon-dashicons'] = 'welcome-learn-more';
        $newTable['table-icon-ionicons'] = 'quote';
        $newTable['table-variable-as-label'] = 'score_name';
        $newTable['table-variable-as-value'] = 'score_id';
        $newTable['form-filter-duplicate'] = true;
        $newTable['auth-enable'] = false;
        $newTable['form-method'] = 'get';


        $x = 0;
        $newTable['table-cols'][$x]['type'] = 'id';
        $newTable['table-cols'][$x]['label'] = 'ID';
        $newTable['table-cols'][$x]['variable'] = 'score_id';
        $newTable['table-cols'][$x]['option'] = '';
        $newTable['table-cols'][$x]['default'] = '';
        $newTable['table-cols'][$x]['info'] = '';
        $newTable['table-cols'][$x]['json-list'] = true;
        $newTable['table-cols'][$x]['json-detail'] = true;
        $newTable['table-cols'][$x]['item-list'] = true;

        $x++;
        $newTable['table-cols'][$x]['type'] = 'varchar';
        $newTable['table-cols'][$x]['label'] = 'Names of Player';
        $newTable['table-cols'][$x]['variable'] = 'player_name';
        $newTable['table-cols'][$x]['option'] = '';
        $newTable['table-cols'][$x]['default'] = '';
        $newTable['table-cols'][$x]['info'] = 'Write the names of player';
        $newTable['table-cols'][$x]['json-list'] = true;
        $newTable['table-cols'][$x]['json-detail'] = true;
        $newTable['table-cols'][$x]['item-list'] = true;
        $newTable['table-cols'][$x]['json-input'] = true;

        $x++;
        $newTable['table-cols'][$x]['type'] = 'text';
        $newTable['table-cols'][$x]['label'] = 'Note';
        $newTable['table-cols'][$x]['variable'] = 'player_note';
        $newTable['table-cols'][$x]['option'] = '';
        $newTable['table-cols'][$x]['default'] = '';
        $newTable['table-cols'][$x]['info'] = 'Write additional information, such as: classroom';
        $newTable['table-cols'][$x]['json-list'] = true;
        $newTable['table-cols'][$x]['json-detail'] = true;
        $newTable['table-cols'][$x]['item-list'] = true;
        $newTable['table-cols'][$x]['json-input'] = true;

        $x++;
        $newTable['table-cols'][$x]['type'] = 'number';
        $newTable['table-cols'][$x]['label'] = 'Score Earned ';
        $newTable['table-cols'][$x]['variable'] = 'score_value';
        $newTable['table-cols'][$x]['option'] = '9';
        $newTable['table-cols'][$x]['default'] = '0';
        $newTable['table-cols'][$x]['info'] = 'Write down the values that have been obtained';
        $newTable['table-cols'][$x]['json-list'] = true;
        $newTable['table-cols'][$x]['json-detail'] = true;
        $newTable['table-cols'][$x]['item-list'] = true;
        $newTable['table-cols'][$x]['json-input'] = true;

        $x++;
        $newTable['table-cols'][$x]['type'] = 'number';
        $newTable['table-cols'][$x]['label'] = 'Time Used';
        $newTable['table-cols'][$x]['variable'] = 'score_time';
        $newTable['table-cols'][$x]['option'] = '';
        $newTable['table-cols'][$x]['default'] = '';
        $newTable['table-cols'][$x]['info'] = 'Write down the time that has been used (second)';
        $newTable['table-cols'][$x]['json-list'] = true;
        $newTable['table-cols'][$x]['json-detail'] = true;
        $newTable['table-cols'][$x]['item-list'] = true;
        $newTable['table-cols'][$x]['json-input'] = true;

        $x++;
        $newTable['table-cols'][$x]['type'] = 'number';
        $newTable['table-cols'][$x]['label'] = 'Number of Questions';
        $newTable['table-cols'][$x]['variable'] = 'score_number_questions';
        $newTable['table-cols'][$x]['option'] = '9';
        $newTable['table-cols'][$x]['default'] = '0';
        $newTable['table-cols'][$x]['info'] = 'Write down the number of questions that have been asked';
        $newTable['table-cols'][$x]['json-list'] = true;
        $newTable['table-cols'][$x]['json-detail'] = true;
        $newTable['table-cols'][$x]['item-list'] = true;
        $newTable['table-cols'][$x]['json-input'] = true;


        $db->saveTable($newTable);

    }

    //TODO: ===============================================================

    // TODO: GENERATOR --|-- INIT VAR
    $service_name = $current_page_target;
    $service_class = $string->toClassName($current_page_target) . 'Service';
    $service_var = $string->toUserClassName($current_page_target) . 'Service';


    $page_name = $current_page_target;
    $page_class = $string->toClassName($current_page_target) . 'Page';
    $page_var = $string->toUserClassName($current_page_target) . 'Page';

    $db_name = $current_page_target . '-questions';

    //TODO: ===============================================================

    // TODO: GENERATOR --|-- SERVICES
    $service['name'] = $service_name;
    $service['instruction'] = 'Service for Multiple Choice Question';
    $service['desc'] = 'Service for Multiple Choice Question';
    $z = 0;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'HttpClient';
    $service['modules']['angular'][$z]['var'] = 'httpClient';
    $service['modules']['angular'][$z]['path'] = '@angular/common/http';
    $z++;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'HttpErrorResponse';
    $service['modules']['angular'][$z]['var'] = '';
    $service['modules']['angular'][$z]['path'] = '@angular/common/http';
    $z++;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'Observable';
    $service['modules']['angular'][$z]['var'] = '';
    $service['modules']['angular'][$z]['path'] = 'rxjs';
    $z++;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'throwError';
    $service['modules']['angular'][$z]['var'] = '';
    $service['modules']['angular'][$z]['path'] = 'rxjs';
    $z++;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'of';
    $service['modules']['angular'][$z]['var'] = '';
    $service['modules']['angular'][$z]['path'] = 'rxjs';
    $z++;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'map';
    $service['modules']['angular'][$z]['var'] = '';
    $service['modules']['angular'][$z]['path'] = 'rxjs/operators';
    $z++;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'catchError';
    $service['modules']['angular'][$z]['var'] = '';
    $service['modules']['angular'][$z]['path'] = 'rxjs/operators';
    $z++;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'retry';
    $service['modules']['angular'][$z]['var'] = '';
    $service['modules']['angular'][$z]['path'] = 'rxjs/operators';
    $z++;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'HttpHeaders';
    $service['modules']['angular'][$z]['var'] = '';
    $service['modules']['angular'][$z]['path'] = '@angular/common/http';
    $z++;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'LoadingController';
    $service['modules']['angular'][$z]['var'] = 'loadingController';
    $service['modules']['angular'][$z]['path'] = '@ionic/angular';
    $z++;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'ToastController';
    $service['modules']['angular'][$z]['var'] = 'toastController';
    $service['modules']['angular'][$z]['path'] = '@ionic/angular';
    $z++;
    $service['modules']['angular'][$z]['enable'] = true;
    $service['modules']['angular'][$z]['class'] = 'AlertController';
    $service['modules']['angular'][$z]['var'] = 'alertController';
    $service['modules']['angular'][$z]['path'] = '@ionic/angular';
    $service['code']['other'] = null;
    $service['code']['other'] .= "\t" . '' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";
    $service['code']['other'] .= "\t" . 'mainUrl: string = `' . $addons['api-url'] . '`;' . "\r\n";
    $service['code']['other'] .= "\t" . 'connectionLost: string = `' . $addons['label-for-connection-lost'] . '`;' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";
    $service['code']['other'] .= "\t" . 'loading: any ;' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";
    // TODO: GENERATOR --|-- SERVICES --|-- getQuestions()
    $service['code']['other'] .= "\t" . '/**' . "\r\n";
    $service['code']['other'] .= "\t" . '* ' . $service_class . '.getQuestions()' . "\r\n";
    $service['code']['other'] .= "\t" . '**/' . "\r\n";
    $service['code']['other'] .= "\t" . 'getQuestions(table:string): Observable<any>{' . "\r\n";
    $service['code']['other'] .= "\t\t" . 'this.presentLoading();' . "\r\n";
    switch ($addons['backend-used'])
    {
        case 'php-native':
            $service['code']['other'] .= "\t\t" . 'let apiUrl: string = `${this.mainUrl}?api=${table}&orderby=random`;' . "\r\n";
            break;
        case 'wp-plugin':
            $wp_prefix = str_replace(array(
                '0',
                '1',
                '2',
                '3',
                '4',
                '5',
                '6',
                '7',
                '8',
                '9'), '', strtolower(metaphone($current_app['apps']['app-name'], 3)));
            $service['code']['other'] .= "\t\t" . 'let apiUrl: string = `${this.mainUrl}/wp-json/wp/v2/' . $wp_prefix . '_${table}/`;' . "\r\n";
            break;
        case 'json-offline':
            $service['code']['other'] .= "\t\t" . 'let apiUrl: string = `assets/data/${table}.json`;' . "\r\n";
            break;
        case 'json-online':
            $service['code']['other'] .= "\t\t" . 'let apiUrl: string = `${this.mainUrl}`;' . "\r\n";
            break;
    }
    $service['code']['other'] .= "\t\t" . 'return this.httpClient.get(apiUrl)' . "\r\n";
    $service['code']['other'] .= "\t\t\t" . '.pipe(' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t" . 'map(results => {' . "\r\n";
    if ($is_debug == true)
    {
        $service['code']['other'] .= "\t\t\t\t\t" . 'console.log(`QuoteService`,`getQuotes`,results);' . "\r\n";
    }
    $service['code']['other'] .= "\t\t\t\t\t" . 'this.dismissLoading();' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t\t" . 'return results;' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t" . '}),' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t" . 'catchError(err => {' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t\t" . 'this.dismissLoading();' . "\r\n";
    if ($is_debug == true)
    {
        $service['code']['other'] .= "\t\t\t\t\t" . 'console.log(`QuoteService`,`getQuotes`,`throwError`, err);' . "\r\n";
    }
    $service['code']['other'] .= "\t\t\t\t\t" . 'if(err.error.message){' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t\t\t" . 'this.showToast(err.error.message);' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t\t" . '}else{' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t\t\t" . 'this.showAlert(null,`' . $current_page_target . '`,this.connectionLost);' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t\t" . '}' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t\t" . 'return throwError(err);' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t" . '}),' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t" . 'catchError(err => {' . "\r\n";
    if ($is_debug == true)
    {
        $service['code']['other'] .= "\t\t\t\t\t" . 'console.log(`QuoteService`,`getQuotes`,`reThrown`, err);' . "\r\n";
    }
    $service['code']['other'] .= "\t\t\t\t\t" . 'return of([]);' . "\r\n";
    $service['code']['other'] .= "\t\t\t\t" . '})' . "\r\n";
    $service['code']['other'] .= "\t\t\t" . ');' . "\r\n";
    $service['code']['other'] .= "\t" . '}' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";

    if ($record_score == true)
    {
        // TODO: GENERATOR --|-- SERVICES --|-- submitScore()
        $service['code']['other'] .= "\t" . '/**' . "\r\n";
        $service['code']['other'] .= "\t" . '* ' . $service_class . '.submitScore(table:string,param:any)' . "\r\n";
        $service['code']['other'] .= "\t" . '**/' . "\r\n";
        $service['code']['other'] .= "\t" . 'submitScore(table:string,param:any): Observable<any>{' . "\r\n";
        $service['code']['other'] .= "\t\t" . 'this.presentLoading();' . "\r\n";
        $service['code']['other'] .= "\t\t" . 'let parameter:string = this.httpBuildQuery(param);' . "\r\n";
        switch ($addons['backend-used'])
        {
            case 'php-native':
                $service['code']['other'] .= "\t\t" . 'let apiUrl: string = `${this.mainUrl}?api=form-sc-${table}&${parameter}`;' . "\r\n";
                break;
            case 'wp-plugin':
                $wp_prefix = str_replace(array(
                    '0',
                    '1',
                    '2',
                    '3',
                    '4',
                    '5',
                    '6',
                    '7',
                    '8',
                    '9'), '', strtolower(metaphone($current_app['apps']['app-name'], 3)));
                $service['code']['other'] .= "\t\t" . 'let apiUrl: string = `${this.mainUrl}/wp-json/wp/v2/' . $wp_prefix . '_form_sc_${table}/?${parameter}`;' . "\r\n";
                break;
        }
        $service['code']['other'] .= "\t\t" . 'return this.httpClient.get(apiUrl)' . "\r\n";
        $service['code']['other'] .= "\t\t\t" . '.pipe(' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t" . 'map(results => {' . "\r\n";
        if ($is_debug == true)
        {
            $service['code']['other'] .= "\t\t\t\t\t" . 'console.log(`QuoteService`,`getQuotes`,results);' . "\r\n";
        }
        $service['code']['other'] .= "\t\t\t\t\t" . 'this.dismissLoading();' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t\t" . 'return results;' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t" . '}),' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t" . 'catchError(err => {' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t\t" . 'this.dismissLoading();' . "\r\n";
        if ($is_debug == true)
        {
            $service['code']['other'] .= "\t\t\t\t\t" . 'console.log(`QuoteService`,`getQuotes`,`throwError`, err);' . "\r\n";
        }
        $service['code']['other'] .= "\t\t\t\t\t" . 'if(err.error.message){' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t\t\t" . 'this.showToast(err.error.message);' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t\t" . '}else{' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t\t\t" . 'this.showAlert(null,`' . $current_page_target . '`,this.connectionLost);' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t\t" . '}' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t\t" . 'return throwError(err);' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t" . '}),' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t" . 'catchError(err => {' . "\r\n";
        if ($is_debug == true)
        {
            $service['code']['other'] .= "\t\t\t\t\t" . 'console.log(`QuoteService`,`getQuotes`,`reThrown`, err);' . "\r\n";
        }
        $service['code']['other'] .= "\t\t\t\t\t" . 'return of([]);' . "\r\n";
        $service['code']['other'] .= "\t\t\t\t" . '})' . "\r\n";
        $service['code']['other'] .= "\t\t\t" . ');' . "\r\n";
        $service['code']['other'] .= "\t" . '}' . "\r\n";
        $service['code']['other'] .= "\t" . '' . "\r\n";
        $service['code']['other'] .= "\t" . '' . "\r\n";

        // TODO: GENERATOR --|-- SERVICES --|-- httpBuildQuery()
        $service['code']['other'] .= "\t" . '/**' . "\r\n";
        $service['code']['other'] .= "\t" . '* ' . $service_class . ':httpBuildQuery(obj)' . "\r\n";
        $service['code']['other'] .= "\t" . '* @param object $obj' . "\r\n";
        $service['code']['other'] .= "\t" . '**/' . "\r\n";
        $service['code']['other'] .= "\t" . 'private httpBuildQuery(obj) {' . "\r\n";
        $service['code']['other'] .= "\t\t" . 'let k, str;' . "\r\n";
        $service['code']['other'] .= "\t\t" . 'str = [];' . "\r\n";
        $service['code']['other'] .= "\t\t" . 'for (k in obj) {' . "\r\n";
        $service['code']['other'] .= "\t\t\t" . 'str.push(encodeURIComponent(k) + "=" + encodeURIComponent(obj[k]));' . "\r\n";
        $service['code']['other'] .= "\t\t" . '}' . "\r\n";
        $service['code']['other'] .= "\t\t" . 'return str.join("&");' . "\r\n";
        $service['code']['other'] .= "\t" . '}' . "\r\n";
        $service['code']['other'] .= "\t" . '' . "\r\n";
        $service['code']['other'] .= "\t" . '' . "\r\n";

    }


    // TODO: GENERATOR --|-- SERVICES --|-- presentLoading()
    $service['code']['other'] .= "\t" . '/**' . "\r\n";
    $service['code']['other'] .= "\t" . '* ' . $service_class . '.presentLoading()' . "\r\n";
    $service['code']['other'] .= "\t" . '**/' . "\r\n";
    $service['code']['other'] .= "\t" . 'async presentLoading() {' . "\r\n";
    $service['code']['other'] .= "\t\t" . 'this.loading = await this.loadingController.create({' . "\r\n";
    if ($addons['multiple-language'] == true)
    {
        $service['code']['other'] .= "\t\t\t" . 'message: this.translateService.instant("' . $addons['label-for-please-wait'] . '"),' . "\r\n";
    } else
    {
        $service['code']['other'] .= "\t\t\t" . 'message: "' . $addons['label-for-please-wait'] . '",' . "\r\n";
    }
    $service['code']['other'] .= "\t\t\t" . 'spinner: "crescent",' . "\r\n";
    $service['code']['other'] .= "\t\t\t" . 'duration: 2000' . "\r\n";
    $service['code']['other'] .= "\t\t" . '});' . "\r\n";
    $service['code']['other'] .= "\t\t" . 'await this.loading.present();' . "\r\n";
    $service['code']['other'] .= "\t" . '}' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";
    $service['code']['other'] .= "\t" . '/**' . "\r\n";
    $service['code']['other'] .= "\t" . '* ' . $service_class . '.dismissLoading()' . "\r\n";
    $service['code']['other'] .= "\t" . '**/' . "\r\n";
    $service['code']['other'] .= "\t" . 'async dismissLoading() {' . "\r\n";
    $service['code']['other'] .= "\t\t" . 'if(this.loading){' . "\r\n";
    $service['code']['other'] .= "\t\t\t" . 'await this.loading.dismiss();' . "\r\n";
    $service['code']['other'] .= "\t\t" . '}' . "\r\n";
    $service['code']['other'] .= "\t" . '}' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";
    // TODO: GENERATOR --|-- SERVICES --|-- showToast()
    $service['code']['other'] .= "\t" . '/**' . "\r\n";
    $service['code']['other'] .= "\t" . '* ' . $service_class . '.showToast($message)' . "\r\n";
    $service['code']['other'] .= "\t" . '**/' . "\r\n";
    $service['code']['other'] .= "\t" . 'async showToast(message: string){' . "\r\n";
    $service['code']['other'] .= "\t\t" . 'const toast = await this.toastController.create({' . "\r\n";
    $service['code']['other'] .= "\t\t\t" . 'message: message,' . "\r\n";
    $service['code']['other'] .= "\t\t\t" . 'position: "bottom",' . "\r\n";
    $service['code']['other'] .= "\t\t\t" . 'color: "dark",' . "\r\n";
    $service['code']['other'] .= "\t\t\t" . 'duration: 500' . "\r\n";
    $service['code']['other'] .= "\t\t" . '});' . "\r\n";
    $service['code']['other'] .= "\t\t" . 'await toast.present();' . "\r\n";
    $service['code']['other'] .= "\t" . '}' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";
    // TODO: GENERATOR --|-- SERVICES --|-- showAlert()
    $service['code']['other'] .= "\t" . '/**' . "\r\n";
    $service['code']['other'] .= "\t" . '* ' . $service_class . '.showAlert()' . "\r\n";
    $service['code']['other'] .= "\t" . '**/' . "\r\n";
    $service['code']['other'] .= "\t" . 'async showAlert(textHeader:string, textSubheader: string, textMessage: string){' . "\r\n";
    $service['code']['other'] .= "\t\t" . 'const alert = await this.alertController.create({' . "\r\n";
    $service['code']['other'] .= "\t\t\t" . 'header: textHeader,' . "\r\n";
    $service['code']['other'] .= "\t\t\t" . 'subHeader: textSubheader,' . "\r\n";
    $service['code']['other'] .= "\t\t\t" . 'message: textMessage,' . "\r\n";
    if ($addons['multiple-language'] == true)
    {
        $service['code']['other'] .= "\t\t\t" . 'buttons: [this.translateService.instant("' . $addons['label-for-ok'] . '")]' . "\r\n";
    } else
    {
        $service['code']['other'] .= "\t\t\t" . 'buttons: ["' . $addons['label-for-ok'] . '"]' . "\r\n";
    }

    $service['code']['other'] .= "\t\t" . '});' . "\r\n";
    $service['code']['other'] .= "\t\t" . 'await alert.present();' . "\r\n";
    $service['code']['other'] .= "\t" . '}' . "\r\n";
    $service['code']['other'] .= "\t" . '' . "\r\n";
    $db->saveService($service, $current_page_target);

    //TODO: ===============================================================
    // TODO: GENERATOR --|-- THEME --|--

    $scss = null;
    $scss .= "" . '/** MULTIPLE CHOICE QUESTION CSS **/' . "\r\n";
    $scss .= "" . '.mcq-dialog .answer-result{' . "\r\n";
    $scss .= "\t" . 'text-align: center !important;' . "\r\n";
    $scss .= "" . '}' . "\r\n";
    $scss .= "" . '.mcq-dialog .answer-icon{' . "\r\n";
    $scss .= "\t" . 'font-size: 48px !important;' . "\r\n";
    $scss .= "" . '}' . "\r\n";
    $scss .= "" . '.mcq-dialog .answer-icon.wrong{' . "\r\n";
    $scss .= "\t" . 'color:red;' . "\r\n";
    $scss .= "" . '}' . "\r\n";
    $scss .= "" . '.mcq-dialog .answer-icon.correct{' . "\r\n";
    $scss .= "\t" . 'color: green;' . "\r\n";
    $scss .= "" . '}' . "\r\n";
    $scss .= "" . '.mcq-dialog blockquote{' . "\r\n";
    $scss .= "\t" . 'font-style: italic;' . "\r\n";
    $scss .= "\t" . 'font-size: 11px;' . "\r\n";
    $scss .= "\t" . 'padding: 3px;' . "\r\n";
    $scss .= "\t" . 'margin:0;' . "\r\n";
    $scss .= "" . '}' . "\r\n";
    $scss .= "" . '.mcq-dialog p{' . "\r\n";
    $scss .= "\t" . 'padding: 3px;' . "\r\n";
    $scss .= "\t" . 'margin:0;' . "\r\n";
    $scss .= "" . '}' . "\r\n";
    $scss .= "" . '.mcq-dialog h3{' . "\r\n";
    $scss .= "\t" . 'padding: 3px;' . "\r\n";
    $scss .= "\t" . 'margin:0;' . "\r\n";
    $scss .= "" . '}' . "\r\n";
    $scss .= "" . '.mcq-dialog h4{' . "\r\n";
    $scss .= "\t" . 'padding: 3px;' . "\r\n";
    $scss .= "\t" . 'margin:0;' . "\r\n";
    $scss .= "" . '}' . "\r\n";
    $scss .= "" . '.mcq-dialog h5{' . "\r\n";
    $scss .= "\t" . 'padding: 3px;' . "\r\n";
    $scss .= "\t" . 'margin:0;' . "\r\n";
    $scss .= "" . '}' . "\r\n";

    $themes['global'] = $scss;
    $db->saveThemes($themes);

    //TODO: ===============================================================
    // TODO: GENERATOR --|-- PAGE --|--
    // create properties for page
    $newPage = null;
    $newPage['title'] = $addons['page-title'];
    $newPage['name'] = $page_name;
    $newPage['code-by'] = 'multiple-choice-question';
    $newPage['icon-left'] = 'help-circle';
    $newPage['icon-right'] = 'help-circle';
    $newPage['header']['color'] = $addons['page-header-color'];
    $newPage['content']['color'] = 'none';
    $newPage['content']['custom-color'] = '#ffffff';
    $newPage['content']['background'] = $addons['page-content-background'];

    $newPage['statusbar']['style'] = 'lightcontent';
    $newPage['statusbar']['backgroundcolor'] = $db->getRawColorLevel($addons['page-header-color']);


    // TODO: GENERATOR --|-- PAGE --|-- HEADER

    $newPage['header']['mid']['type'] = 'title';
    $newPage['header']['mid']['items'][0]['label'] = 'Tab 1';
    $newPage['header']['mid']['items'][0]['value'] = 'tab1';
    $newPage['header']['mid']['items'][1]['label'] = 'Tab 2';
    $newPage['header']['mid']['items'][1]['value'] = 'tab2';
    $newPage['header']['mid']['items'][2]['label'] = 'Tab 3';
    $newPage['header']['mid']['items'][2]['value'] = 'tab3';
    // TODO: GENERATOR --|-- PAGE --|-- MODULES
    $z = 0;
    $newPage['modules']['angular'][$z]['enable'] = true;
    $newPage['modules']['angular'][$z]['class'] = 'Observable';
    $newPage['modules']['angular'][$z]['var'] = '';
    $newPage['modules']['angular'][$z]['path'] = 'rxjs';

    $z++;
    $newPage['modules']['angular'][$z]['enable'] = true;
    $newPage['modules']['angular'][$z]['class'] = 'AlertController';
    $newPage['modules']['angular'][$z]['var'] = 'alertController';
    $newPage['modules']['angular'][$z]['path'] = '@ionic/angular';

    $z++;
    $newPage['modules']['angular'][$z]['enable'] = true;
    $newPage['modules']['angular'][$z]['class'] = $service_class;
    $newPage['modules']['angular'][$z]['var'] = $service_var;
    $newPage['modules']['angular'][$z]['path'] = './../../services/' . $service_name . '/' . $service_name . '.service';

    $z++;
    $newPage['modules']['angular'][$z]['enable'] = true;
    $newPage['modules']['angular'][$z]['class'] = 'LoadingController';
    $newPage['modules']['angular'][$z]['var'] = 'loadingController';
    $newPage['modules']['angular'][$z]['path'] = '@ionic/angular';
    $z++;
    $newPage['modules']['angular'][$z]['enable'] = true;
    $newPage['modules']['angular'][$z]['class'] = 'Validators';
    $newPage['modules']['angular'][$z]['var'] = '';
    $newPage['modules']['angular'][$z]['path'] = '@angular/forms';
    $z++;
    $newPage['modules']['angular'][$z]['enable'] = true;
    $newPage['modules']['angular'][$z]['class'] = 'FormBuilder';
    $newPage['modules']['angular'][$z]['var'] = 'formBuilder';
    $newPage['modules']['angular'][$z]['path'] = '@angular/forms';
    $z++;
    $newPage['modules']['angular'][$z]['enable'] = true;
    $newPage['modules']['angular'][$z]['class'] = 'FormGroup';
    $newPage['modules']['angular'][$z]['var'] = '';
    $newPage['modules']['angular'][$z]['path'] = '@angular/forms';
    $z++;
    $newPage['modules']['angular'][$z]['enable'] = true;
    $newPage['modules']['angular'][$z]['class'] = 'FormControl';
    $newPage['modules']['angular'][$z]['var'] = '';
    $newPage['modules']['angular'][$z]['path'] = '@angular/forms';
    // TODO: GENERATOR --|-- PAGE --|-- CONTENT --|-- HTML
    $newPage['content']['html'] = null;
    $newPage['content']['html'] .= '<ion-card>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '' . "\r\n";
    $newPage['content']['html'] .= "\t" . '<ion-card-header>' . "\r\n";
    $newPage['content']['html'] .= "\t\t" . '<ion-card-title>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '<ion-text>{{ \'' . $addons['label-for-question'] . '\'' . $pipe_translate . '}}</ion-text>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '<ion-button color="medium" class="update" (click)="updateStoreQuestion()" size="small"><ion-icon name="cloud-download-outline"></ion-icon> {{ \'' . $addons['label-for-update'] . '\'' . $pipe_translate . '}}</ion-button>' . "\r\n";
    $newPage['content']['html'] .= "\t\t" . '</ion-card-title>' . "\r\n";
    $newPage['content']['html'] .= "\t\t" . '<ion-card-subtitle>{{ NoQuestion }}/{{ totalQuestions }}</ion-card-subtitle>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '</ion-card-header>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '' . "\r\n";
    $newPage['content']['html'] .= "\t" . '<ion-card-content *ngIf="currentQuestion && currentQuestion.question_content" innerHTML="{{ currentQuestion.question_content }}"></ion-card-content>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '' . "\r\n";
    $newPage['content']['html'] .= "\t" . '<ion-card-content *ngIf="!currentQuestion || !currentQuestion.question_content">' . "\r\n";
    $newPage['content']['html'] .= "\t\t" . '<ion-skeleton-text animated></ion-skeleton-text>' . "\r\n";
    $newPage['content']['html'] .= "\t\t" . '<ion-skeleton-text animated></ion-skeleton-text>' . "\r\n";
    $newPage['content']['html'] .= "\t\t" . '<ion-skeleton-text animated></ion-skeleton-text>' . "\r\n";
    $newPage['content']['html'] .= "\t\t" . '<ion-skeleton-text animated style="width: 70%"></ion-skeleton-text>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '</ion-card-content>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '' . "\r\n";
    $newPage['content']['html'] .= "\t" . '<ion-img *ngIf="currentQuestion && currentQuestion.question_image && currentQuestion.question_image != \'\' " src="{{ currentQuestion.question_image }}" ></ion-img>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '' . "\r\n";
    $newPage['content']['html'] .= "\t" . '<ion-list [formGroup]="formAnswers">' . "\r\n";
    $newPage['content']['html'] .= "\t\t" . '<ion-radio-group formControlName="choice">' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '<ion-list-header>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-label>{{ \'' . $addons['label-for-your-choice'] . '\'' . $pipe_translate . '}}</ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '</ion-list-header>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '<ion-item lines="none" *ngIf="currentQuestion && currentQuestion.choice_a">' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-label class="ion-text-wrap">{{ currentQuestion.choice_a }}</ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-radio color="danger" slot="start" value="A"></ion-radio>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '</ion-item>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '<ion-item *ngIf="!currentQuestion || !currentQuestion.choice_a">' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t\t" . '<ion-skeleton-text animated></ion-skeleton-text>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t\t" . '<ion-skeleton-text animated style="width: 70%"></ion-skeleton-text>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '</ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-radio color="danger" slot="start" value="A"></ion-radio>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '</ion-item>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '<ion-item lines="none" *ngIf="currentQuestion && currentQuestion.choice_b">' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-label class="ion-text-wrap">{{ currentQuestion.choice_b }}</ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-radio color="danger" slot="start" value="B"></ion-radio>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '</ion-item>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '<ion-item *ngIf="!currentQuestion || !currentQuestion.choice_b">' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t\t" . '<ion-skeleton-text animated></ion-skeleton-text>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t\t" . '<ion-skeleton-text animated style="width: 70%"></ion-skeleton-text>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '</ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-radio color="danger" slot="start" value="B"></ion-radio>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '</ion-item>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '<ion-item lines="none" *ngIf="currentQuestion && currentQuestion.choice_c">' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-label class="ion-text-wrap">{{ currentQuestion.choice_c }}</ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-radio color="danger" slot="start" value="C"></ion-radio>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '</ion-item>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '<ion-item *ngIf="!currentQuestion || !currentQuestion.choice_c">' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t\t" . '<ion-skeleton-text animated></ion-skeleton-text>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t\t" . '<ion-skeleton-text animated style="width: 70%"></ion-skeleton-text>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '</ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-radio color="danger" slot="start" value="C"></ion-radio>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '</ion-item>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '<ion-item lines="none" *ngIf="currentQuestion && currentQuestion.choice_d">' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-label class="ion-text-wrap">{{ currentQuestion.choice_d }}</ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-radio color="danger" slot="start" value="D"></ion-radio>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '</ion-item>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '<ion-item lines="none" *ngIf="currentQuestion && currentQuestion.choice_e">' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-label class="ion-text-wrap">{{ currentQuestion.choice_e }}</ion-label>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t\t" . '<ion-radio color="danger" slot="start" value="E"></ion-radio>' . "\r\n";
    $newPage['content']['html'] .= "\t\t\t" . '</ion-item>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '' . "\r\n";
    $newPage['content']['html'] .= "\t\t" . '</ion-radio-group>' . "\r\n";
    $newPage['content']['html'] .= "\t" . '</ion-list>' . "\r\n";
    $newPage['content']['html'] .= '</ion-card>' . "\r\n";


    $newPage['footer']['color'] = 'none';
    $newPage['footer']['type'] = 'code';
    $newPage['footer']['title'] = '';

    $newPage['footer']['code'] = null;
    $newPage['footer']['code'] .= "\t" . '' . "\r\n";
    $newPage['footer']['code'] .= "\t" . '<ion-grid>' . "\r\n";
    $newPage['footer']['code'] .= "\t\t" . '<ion-row>' . "\r\n";
    $newPage['footer']['code'] .= "\t\t\t" . '<ion-col size="3">' . "\r\n";
    if ($addons['show-answers-and-scores'] == true)
    {
        $newPage['footer']['code'] .= "\t\t\t\t" . '<p>{{ \'' . $addons['label-for-score'] . '\'' . $pipe_translate . '}}</p>' . "\r\n";
        $newPage['footer']['code'] .= "\t\t\t\t" . '<h4>{{ yourScore }} <small>({{answerTime}}s)</small></h4>' . "\r\n";
    } else
    {
        $newPage['footer']['code'] .= "\t\t\t\t" . '<h4>{{answerTime}}s</h4>' . "\r\n";
    }
    $newPage['footer']['code'] .= "\t\t\t" . '</ion-col>' . "\r\n";
    $newPage['footer']['code'] .= "\t\t\t" . '<ion-col size="3">' . "\r\n";
    $newPage['footer']['code'] .= "\t\t\t" . '</ion-col>' . "\r\n";
    $newPage['footer']['code'] .= "\t\t\t" . '<ion-col size="6">' . "\r\n";
    $newPage['footer']['code'] .= "\t\t\t\t" . '<ion-button *ngIf="yourAnswer == \'\'" disabled="true" fill="solid" expand="block" color="' . $addons['page-header-color'] . '">{{ \'' . $addons['label-for-sure-i-agree'] . '\'' . $pipe_translate . '}}</ion-button>' . "\r\n";
    $newPage['footer']['code'] .= "\t\t\t\t" . '<ion-button *ngIf="yourAnswer != \'\'" (click)="checkAnswer()" fill="solid" expand="block" color="' . $addons['page-header-color'] . '">{{ \'' . $addons['label-for-sure-i-agree'] . '\'' . $pipe_translate . '}}</ion-button>' . "\r\n";
    $newPage['footer']['code'] .= "\t\t\t" . '</ion-col>' . "\r\n";
    $newPage['footer']['code'] .= "\t\t" . '</ion-row>' . "\r\n";
    $newPage['footer']['code'] .= "\t" . '</ion-grid>' . "\r\n";
    $newPage['footer']['code'] .= "\t" . '' . "\r\n";

    // TODO: GENERATOR --|-- PAGE --|-- CONTENT --|-- SCSS
    $newPage['content']['scss'] = null;
    $newPage['content']['scss'] .= "" . 'ion-card {' . "\r\n";
    $newPage['content']['scss'] .= "\t" . '--background: #fff;' . "\r\n";
    $newPage['content']['scss'] .= "\t" . 'opacity:0.9;' . "\r\n";
    $newPage['content']['scss'] .= "" . '}' . "\r\n";
    $newPage['content']['scss'] .= "" . 'ion-button.update{' . "\r\n";
    $newPage['content']['scss'] .= "\t" . 'position: absolute;' . "\r\n";
    $newPage['content']['scss'] .= "\t" . 'right: 0;' . "\r\n";
    $newPage['content']['scss'] .= "" . '}' . "\r\n";
    $newPage['content']['scss'] .= "" . 'ion-footer{' . "\r\n";
    $newPage['content']['scss'] .= "\t" . 'p{' . "\r\n";
    $newPage['content']['scss'] .= "\t\t" . 'padding: 0;' . "\r\n";
    $newPage['content']['scss'] .= "\t\t" . 'margin: 0;' . "\r\n";
    $newPage['content']['scss'] .= "\t" . '}' . "\r\n";
    $newPage['content']['scss'] .= "\t" . 'h4{' . "\r\n";
    $newPage['content']['scss'] .= "\t\t" . 'padding: 0;' . "\r\n";
    $newPage['content']['scss'] .= "\t\t" . 'margin: 0;' . "\r\n";
    $newPage['content']['scss'] .= "\t" . '}' . "\r\n";
    $newPage['content']['scss'] .= "" . '}' . "\r\n";

    // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER
    $newPage['code']['export'] = null;
    $newPage['code']['constructor'] = null;
    $newPage['code']['other'] = null;
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'questions: Observable<any>;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'dataQuestions: any = [];' . "\r\n";
    if ($record_score == true)
    {
        $newPage['code']['other'] .= "\t" . 'submitScore: Observable<any>;' . "\r\n";
        $newPage['code']['other'] .= "\t" . 'dataSubmitScore: any = {};' . "\r\n";
    }

    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '//current question' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'indexQuestion: number = 0;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'currentQuestion: any = {};' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'formAnswers : FormGroup;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'NoQuestion: number = 1;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'totalQuestions : number = 100;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'yourAnswer : string = ``;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'yourScore : number = 0;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'correctAnswer : string = `A`;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'correctAnswerText : string = `Lorem Ipsum do Ismet`;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'stopQuestion: boolean = false;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'answerTime: number = 0;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'runTimer: any;' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'retry: number = 0;' . "\r\n";

    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER --|-- requestQuestion()
    $newPage['code']['other'] .= "\t" . '/**' . "\r\n";
    $newPage['code']['other'] .= "\t" . '* ' . $page_class . ':requestQuestion()' . "\r\n";
    $newPage['code']['other'] .= "\t" . '**/' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'public requestQuestion(){' . "\r\n";
    $paramTable = $current_page_target;
    switch ($addons['backend-used'])
    {
        case 'php-native':
            $paramTable = $current_page_target;
            break;
        case 'wp-plugin':
            $paramTable = str_replace('-', '_', $current_page_target);
            break;
        case 'json-offline':
            $paramTable = $current_page_target;
            break;
        case 'json-online':
            $paramTable = $current_page_target;
            break;
    }


    $newPage['code']['other'] .= "\t\t" . 'this.questions = this.' . $service_var . '.getQuestions(`' . $paramTable . '`);' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.questions.subscribe(data => {' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'this.storage?.set(`' . $db_name . '`, data).then((e)=>{' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'this.loadQuestion();' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . '});' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . '});' . "\r\n";
    $newPage['code']['other'] .= "\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";

    // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER --|-- checkAnswer()
    $newPage['code']['other'] .= "\t" . '/**' . "\r\n";
    $newPage['code']['other'] .= "\t" . '* ' . $page_class . ':checkAnswer()' . "\r\n";
    $newPage['code']['other'] .= "\t" . '**/' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'async checkAnswer(){' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'if(this.stopQuestion == false){' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'if(this.correctAnswer == this.yourAnswer){' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'this.yourScore++;' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . '}' . "\r\n";


    if ($addons['show-answers-and-scores'] == true)
    {
        $newPage['code']['other'] .= "\t\t\t" . '// dialog' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . 'let textMessage : string = ``;' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . 'if(this.correctAnswer == this.yourAnswer){' . "\r\n";
        if ($addons['multiple-language'] == true)
        {
            $newPage['code']['other'] .= "\t\t\t\t" . 'let text1 : string = this.translateService.instant(`' . $addons['label-for-your-answer-is-correct'] . '`);' . "\r\n";
        } else
        {
            $newPage['code']['other'] .= "\t\t\t\t" . 'let text1 : string = `' . $addons['label-for-your-answer-is-correct'] . '`;' . "\r\n";
        }
        $newPage['code']['other'] .= "\t\t\t\t" . 'textMessage += `<div class="answer-result">`;' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'textMessage += `<div class="answer-icon correct"><ion-icon size="large" name="checkmark-circle"></ion-icon></div>`;' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'textMessage += `<p><strong>${text1}</strong></p>`' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'textMessage += `</div>`;' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . '}else{' . "\r\n";
        if ($addons['multiple-language'] == true)
        {
            $newPage['code']['other'] .= "\t\t\t\t" . 'let text1 : string = this.translateService.instant(`' . $addons['label-for-your-answer-is-wrong'] . '`);' . "\r\n";
        } else
        {
            $newPage['code']['other'] .= "\t\t\t\t" . 'let text1 : string = `' . $addons['label-for-your-answer-is-wrong'] . '`;' . "\r\n";
        }
        if ($addons['multiple-language'] == true)
        {
            $newPage['code']['other'] .= "\t\t\t\t" . 'let text2 : string = this.translateService.instant(`' . $addons['label-for-the-correct-answer-is'] . '`);' . "\r\n";
        } else
        {
            $newPage['code']['other'] .= "\t\t\t\t" . 'let text2 : string = `' . $addons['label-for-the-correct-answer-is'] . '`;' . "\r\n";
        }

        $newPage['code']['other'] .= "\t\t\t\t" . 'textMessage += `<div class="answer-result">`;' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'textMessage += `<div class="answer-icon wrong"><ion-icon size="large" name="close-circle"></ion-icon></div>`;' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'textMessage += `<p><strong>${text1}</strong></p>`' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'textMessage += `<p>${text2}:</p>`' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'textMessage += `<blockquote>"${this.correctAnswerText}"</blockquote>`' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'textMessage += `</div>`;' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . '}' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . '' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . '' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . 'const checkAlert = await this.alertController.create({' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'mode: `ios`,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'cssClass: `mcq-dialog`,' . "\r\n";
        //$newPage['code']['other'] .= "\t\t\t\t" . 'header: textHeader,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'message: textMessage,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . 'buttons:[' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t" . '{' . "\r\n";
        if ($addons['multiple-language'] == true)
        {
            $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'text: this.translateService.instant(`' . $addons['label-for-ok'] . '`),' . "\r\n";
        } else
        {
            $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'text: `' . $addons['label-for-ok'] . '`,' . "\r\n";
        }

        $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'handler: (formInput) =>{' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t\t" . 'this.nextQuestion();' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t" . '}' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t" . '}' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . ']' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . '});' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . 'await checkAlert.present();' . "\r\n";
    } else
    {
        $newPage['code']['other'] .= "\t\t\t" . 'this.nextQuestion();' . "\r\n";
    }
    $newPage['code']['other'] .= "\t\t" . '}else{' . "\r\n";

    // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER --|-- checkAnswer() --|-- stop

    $newPage['code']['other'] .= "\t\t\t" . '//stop' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'clearInterval(this.runTimer);' . "\r\n";

    if ($addons['multiple-language'] == true)
    {
        $newPage['code']['other'] .= "\t\t\t" . 'let text1:string = this.translateService.instant(`' . $addons['label-for-question-run-out'] . '`);' . "\r\n";
    } else
    {
        $newPage['code']['other'] .= "\t\t\t" . 'let text1:string = `' . $addons['label-for-question-run-out'] . '`;' . "\r\n";
    }

    if ($addons['show-answers-and-scores'] == true)
    {
        if ($addons['multiple-language'] == true)
        {
            $newPage['code']['other'] .= "\t\t\t" . 'let text2:string = this.translateService.instant(`' . $addons['label-for-your-score'] . '`);' . "\r\n";
        } else
        {
            $newPage['code']['other'] .= "\t\t\t" . 'let text2:string = `' . $addons['label-for-your-score'] . '`;' . "\r\n";
        }
    }

    $newPage['code']['other'] .= "\t\t\t" . 'let textMessage : string = ``;' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'textMessage += `<p>${text1}</p>`;' . "\r\n";
    if ($addons['show-answers-and-scores'] == true)
    {
        $newPage['code']['other'] .= "\t\t\t" . 'textMessage += `<h5>${text2}</h5>`;' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . 'textMessage += `<h3>${this.yourScore}</h3>`;' . "\r\n";
    }

    if ($addons['multiple-language'] == true)
    {
        $newPage['code']['other'] .= "\t\t\t" . 'let textHeader : string = this.translateService.instant(`' . $addons['label-for-attention'] . '`);' . "\r\n";
    } else
    {
        $newPage['code']['other'] .= "\t\t\t" . 'let textHeader : string = `' . $addons['label-for-attention'] . '`;' . "\r\n";
    }


    $newPage['code']['other'] .= "\t\t\t" . 'const finishAlert = await this.alertController.create({' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'mode: `ios`,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'cssClass: `mcq-dialog`,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'header: textHeader,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'backdropDismiss: false,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'message: textMessage,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'buttons:[' . "\r\n";
    if ($addons['only-one-chance'] != true)
    {
        $newPage['code']['other'] .= "\t\t\t\t\t" . '{' . "\r\n";
        if ($addons['multiple-language'] == true)
        {
            $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'text: this.translateService.instant(`' . $addons['label-for-repeat'] . '`),' . "\r\n";
        } else
        {
            $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'text: `' . $addons['label-for-repeat'] . '`,' . "\r\n";
        }

        $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'handler: (formInput) =>{' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t\t" . 'this.updateQuestion();' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t" . '}' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t" . '},' . "\r\n";
    }

    if ($record_score == true)
    {
        $newPage['code']['other'] .= "\t\t\t\t\t" . '{' . "\r\n";
        if ($addons['multiple-language'] == true)
        {
            $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'text: this.translateService.instant(`' . $addons['label-for-save-score'] . '`),' . "\r\n";
        } else
        {
            $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'text: `' . $addons['label-for-save-score'] . '`,' . "\r\n";
        }
        $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'handler: (formInput) =>{' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t\t" . 'this.saveScore();' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t" . '}' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t" . '},' . "\r\n";
    }

    $newPage['code']['other'] .= "\t\t\t\t" . ']' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . '});' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'await finishAlert.present();' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . '}' . "\r\n";

    $newPage['code']['other'] .= "\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";


    if ($record_score == true)
    {
        $paramTable = $current_page_target;
        switch ($addons['backend-used'])
        {
            case 'php-native':
                $paramTable = $current_page_target;
                break;
            case 'wp-plugin':
                $paramTable = str_replace('-', '_', $current_page_target);
                break;
            case 'json-offline':
                $paramTable = $current_page_target;
                break;
            case 'json-online':
                $paramTable = $current_page_target;
                break;
        }

        // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER --|-- saveScore()
        $newPage['code']['other'] .= "\t" . '/**' . "\r\n";
        $newPage['code']['other'] .= "\t" . '* ' . $page_class . ':saveScore()' . "\r\n";
        $newPage['code']['other'] .= "\t" . '**/' . "\r\n";
        $newPage['code']['other'] .= "\t" . 'async saveScore(){' . "\r\n";

        if ($addons['multiple-language'] == true)
        {
            $newPage['code']['other'] .= "\t\t" . 'let textHeader = this.translateService.instant(`' . $addons['label-for-personal-data'] . '`);' . "\r\n";
        } else
        {
            $newPage['code']['other'] .= "\t\t" . 'let textHeader = `' . $addons['label-for-personal-data'] . '`;' . "\r\n";
        }

        $newPage['code']['other'] .= "\t\t" . 'const formScore = await this.alertController.create({' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . '//mode: `ios`,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . 'cssClass: `mcq-dialog`,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . 'header: textHeader,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . 'backdropDismiss: false,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . 'inputs: [' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . '{' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'id: "player_name",' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'name: "player_name",' . "\r\n";
        if ($addons['multiple-language'] == true)
        {
            $newPage['code']['other'] .= "\t\t\t\t\t" . 'label: this.translateService.instant(`' . $addons['label-for-name'] . '`),' . "\r\n";
        } else
        {
            $newPage['code']['other'] .= "\t\t\t\t\t" . 'label: `' . $addons['label-for-name'] . '`,' . "\r\n";
        }
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'type: "text",' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'placeholder: "Ahmad Dahlan",' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . '},' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . '{' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'id: "player_note",' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'name: "player_note",' . "\r\n";
        if ($addons['multiple-language'] == true)
        {
            $newPage['code']['other'] .= "\t\t\t\t\t" . 'label: this.translateService.instant(`' . $addons['label-for-note'] . '`),' . "\r\n";
        } else
        {
            $newPage['code']['other'] .= "\t\t\t\t\t" . 'label: `' . $addons['label-for-note'] . '`,' . "\r\n";
        }
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'type: "text",' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'placeholder: "3a",' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . '}' . "\r\n";

        $newPage['code']['other'] .= "\t\t\t" . '],' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . 'buttons:[' . "\r\n";

        $newPage['code']['other'] .= "\t\t\t\t" . '{' . "\r\n";
        if ($addons['multiple-language'] == true)
        {
            $newPage['code']['other'] .= "\t\t\t\t\t" . 'text: this.translateService.instant(`' . $addons['label-for-submit'] . '`),' . "\r\n";
        } else
        {
            $newPage['code']['other'] .= "\t\t\t\t\t" . 'text: `' . $addons['label-for-submit'] . '`,' . "\r\n";
        }

        $newPage['code']['other'] .= "\t\t\t\t\t" . 'handler: (formInput) =>{' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'let param:any = {' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t\t" . '"player-name": formInput.player_name,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t\t" . '"player-note": formInput.player_note,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t\t" . '"score-value": this.yourScore,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t\t" . '"score-time": this.answerTime,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t\t" . '"score-number-questions": this.totalQuestions,' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t" . '}' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'console.log(`submit`,param);' . "\r\n";

        $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'this.submitScore = this.' . $service_var . '.submitScore(`' . $paramTable . '`,param);' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'this.submitScore.subscribe(data => {' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t\t" . 'console.log(`submit`,data);' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t\t\t" . 'this.showAlert(data.title,null,data.message);' . "\r\n";

        $newPage['code']['other'] .= "\t\t\t\t\t\t" . '});' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t\t" . '}' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t\t" . '},' . "\r\n";
        $newPage['code']['other'] .= "\t\t\t" . ']' . "\r\n";
        $newPage['code']['other'] .= "\t\t" . '});' . "\r\n";
        $newPage['code']['other'] .= "\t\t" . 'await formScore.present();' . "\r\n";
        $newPage['code']['other'] .= "\t" . '}' . "\r\n";
        $newPage['code']['other'] .= "\t" . '' . "\r\n";
        $newPage['code']['other'] .= "\t" . '' . "\r\n";
    }
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER --|-- nextQuestion()
    $newPage['code']['other'] .= "\t" . '/**' . "\r\n";
    $newPage['code']['other'] .= "\t" . '* ' . $page_class . ':nextQuestion()' . "\r\n";
    $newPage['code']['other'] .= "\t" . '**/' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'public nextQuestion(){' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.formInstance();' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.yourAnswer = ``;' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'if(this.indexQuestion < (this.totalQuestions -1) ){' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'this.indexQuestion++;' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'this.NoQuestion = this.indexQuestion + 1;' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'this.displayQuestion();' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . '}else{' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'this.stopQuestion = true;' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER --|-- updateQuestion()
    $newPage['code']['other'] .= "\t" . '/**' . "\r\n";
    $newPage['code']['other'] .= "\t" . '* ' . $page_class . ':updateQuestion()' . "\r\n";
    $newPage['code']['other'] .= "\t" . '**/' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'public updateQuestion(){' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . '// reset question position' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.indexQuestion = 0;' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.NoQuestion = 1;' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.yourScore = 0;' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.answerTime = 0;' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.stopQuestion = false;' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . '// request new data from server' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.requestQuestion();' . "\r\n";
    $newPage['code']['other'] .= "\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";

    // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER --|-- updateStoreQuestion()
    $newPage['code']['other'] .= "\t" . '/**' . "\r\n";
    $newPage['code']['other'] .= "\t" . '* ' . $page_class . ':updateStoreQuestion()' . "\r\n";
    $newPage['code']['other'] .= "\t" . '**/' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'async updateStoreQuestion(){' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    if ($addons['multiple-language'] == true)
    {
        $newPage['code']['other'] .= "\t\t" . 'let message : string = this.translateService.instant(`' . $addons['label-for-update-the-question'] . '`);' . "\r\n";
    } else
    {
        $newPage['code']['other'] .= "\t\t" . 'let message : string = `' . $addons['label-for-update-the-question'] . '`;' . "\r\n";
    }

    if ($addons['multiple-language'] == true)
    {
        $newPage['code']['other'] .= "\t\t" . 'let header : string = this.translateService.instant(`' . $addons['label-for-attention'] . '`);' . "\r\n";
    } else
    {
        $newPage['code']['other'] .= "\t\t" . 'let header : string = `' . $addons['label-for-attention'] . '`;' . "\r\n";
    }

    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'const alert = await this.alertController.create({' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'mode: `ios`,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'cssClass: `mcq-dialog`,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'header: header,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'message: message,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'buttons:[' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . '{' . "\r\n";
    if ($addons['multiple-language'] == true)
    {
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'text: this.translateService.instant(`' . $addons['label-for-cancel'] . '`),' . "\r\n";
    } else
    {
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'text: `' . $addons['label-for-cancel'] . '`,' . "\r\n";
    }

    $newPage['code']['other'] .= "\t\t\t\t\t" . 'role: `cancel`,' . "\r\n";

    $newPage['code']['other'] .= "\t\t\t\t" . '},' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . '{' . "\r\n";
    if ($addons['multiple-language'] == true)
    {
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'text: this.translateService.instant(`' . $addons['label-for-ok'] . '`),' . "\r\n";
    } else
    {
        $newPage['code']['other'] .= "\t\t\t\t\t" . 'text: `' . $addons['label-for-ok'] . '`,' . "\r\n";
    }

    $newPage['code']['other'] .= "\t\t\t\t\t" . 'handler: (formInput) =>{' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'this.retry = 0;' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t\t\t" . 'this.updateQuestion();' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . ']' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . '});' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'await alert.present();' . "\r\n";

    $newPage['code']['other'] .= "\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";


    // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER --|-- displayQuestion()
    $newPage['code']['other'] .= "\t" . '/**' . "\r\n";
    $newPage['code']['other'] .= "\t" . '* ' . $page_class . ':displayQuestion()' . "\r\n";
    $newPage['code']['other'] .= "\t" . '**/' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'public displayQuestion(){' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.currentQuestion = this.dataQuestions[this.indexQuestion];' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.correctAnswer = this.currentQuestion.correct_answer;' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'let correctText:string = (this.currentQuestion.correct_answer).toLocaleLowerCase();' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'let varName:string = `choice_${correctText}`;' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.correctAnswerText = this.currentQuestion[ varName];' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'console.log(`correctAnswer`,this.correctAnswer,this.correctAnswerText);' . "\r\n";
    $newPage['code']['other'] .= "\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER --|-- loadQuestion()
    $newPage['code']['other'] .= "\t" . '/**' . "\r\n";
    $newPage['code']['other'] .= "\t" . '* ' . $page_class . ':loadQuestion()' . "\r\n";
    $newPage['code']['other'] .= "\t" . '**/' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'public loadQuestion(){' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.dataQuestions = [];' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.storage?.get(`' . $db_name . '`).then((data)=>{' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'if(data && data.length){' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'this.dataQuestions = data;' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'this.totalQuestions = data.length;' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'this.displayQuestion();' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'this.runTimer = setInterval(()=>{' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t\t" . 'this.answerTime++;' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . '},1000);' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'console.log(`Questions`,`storage`,data);' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . '}else{' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . 'if(this.retry < 3){' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t\t" . 'console.log(`Questions`,`online`);' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t\t" . 'this.updateQuestion();' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t\t" . 'this.retry++;' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t\t" . '};' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . '});' . "\r\n";
    $newPage['code']['other'] .= "\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER --|-- formInstance()
    $newPage['code']['other'] .= "\t" . '/**' . "\r\n";
    $newPage['code']['other'] .= "\t" . '* ' . $page_class . ':formInstance()' . "\r\n";
    $newPage['code']['other'] .= "\t" . '**/' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'public formInstance(){' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.formAnswers = this.formBuilder.group({' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'choice : ["", Validators.required]' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . '});' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.formAnswers.valueChanges.subscribe(your_answer => {' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'this.yourAnswer = your_answer.choice;' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'console.log(`yourAnswer`,this.indexQuestion,this.yourAnswer);' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . '});' . "\r\n";
    $newPage['code']['other'] .= "\t" . '}' . "\r\n";


    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '/**' . "\r\n";
    $newPage['code']['other'] .= "\t" . '* ' . $page_class . '.showAlert()' . "\r\n";
    $newPage['code']['other'] .= "\t" . '**/' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'async showAlert(header:string, subheader: string, message: string){' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'const alert = await this.alertController.create({' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'header: header,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'subHeader: subheader,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'message: message,' . "\r\n";
    $newPage['code']['other'] .= "\t\t\t" . 'buttons: ["OK"]' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . '});' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'await alert.present();' . "\r\n";
    $newPage['code']['other'] .= "\t" . '}' . "\r\n";


    // TODO: GENERATOR --|-- PAGE --|-- CODE --|-- OTHER --|-- ngOnInit()
    $newPage['code']['other'] .= "\t" . '/**' . "\r\n";
    $newPage['code']['other'] .= "\t" . '* ' . $page_class . ':ngOnInit()' . "\r\n";
    $newPage['code']['other'] .= "\t" . '**/' . "\r\n";
    $newPage['code']['other'] .= "\t" . 'public ngOnInit(){' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.retry = 0;' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.formInstance();' . "\r\n";
    $newPage['code']['other'] .= "\t\t" . 'this.loadQuestion();' . "\r\n";
    $newPage['code']['other'] .= "\t" . '}' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['other'] .= "\t" . '' . "\r\n";
    $newPage['code']['init'] = null;
    //generate page code
    $db->savePage($newPage);
    $db->current();
    rebuild();
    header('Location: ./?p=addons&addons=multiple-choice-question&page-target=' . $current_page_target . '&' . time());
}
//TODO: ===============================================================
// TODO: INIT --|-- CURRENT SETTINGS
$disabled = null;
if ($current_page_target == '')
{
    $disabled = 'disabled';
    $current_setting = array();
} else
{
    $current_setting = $db->getAddOns('multiple-choice-question', $current_page_target);
}
if (!isset($current_setting['page-target']))
{
    $current_setting['page-target'] = '';
}
if (!isset($current_setting['page-title']))
{
    $current_page_title = '';
    if ($current_page_target != '')
    {
        $current_page = $db->getPage($current_page_target);
        $current_page_title = $current_page['title'];
    }
    $current_setting['page-title'] = $current_page_title;
}
if (!isset($current_setting['page-header-color']))
{
    $current_setting['page-header-color'] = 'primary';
}
if (!isset($current_setting['page-content-background']))
{
    $current_setting['page-content-background'] = 'assets/images/background/bg.jpg';
}
if (!isset($current_setting['backend-used']))
{
    $current_setting['backend-used'] = '';
}
if (!isset($current_setting['api-url']))
{
    $current_setting['api-url'] = '';
}
if (!isset($current_setting['multiple-language']))
{
    $current_setting['multiple-language'] = false;
}

if (!isset($current_setting['show-answers-and-scores']))
{
    $current_setting['show-answers-and-scores'] = false;
}

if (!isset($current_setting['only-one-chance']))
{
    $current_setting['only-one-chance'] = false;
}


// TODO: INIT --|-- CURRENT SETTINGS --|-- LABELS

if (!isset($current_setting['label-for-please-wait']))
{
    $current_setting['label-for-please-wait'] = 'Please wait...!';
}
if (!isset($current_setting['label-for-ok']))
{
    $current_setting['label-for-ok'] = 'OK';
}
if (!isset($current_setting['label-for-connection-lost']))
{
    $current_setting['label-for-connection-lost'] = 'Connection lost, please check your connection!';
}
if (!isset($current_setting['label-for-question']))
{
    $current_setting['label-for-question'] = 'Question';
}
if (!isset($current_setting['label-for-your-choice']))
{
    $current_setting['label-for-your-choice'] = 'Your choice!';
}

if (!isset($current_setting['label-for-your-answer-is-wrong']))
{
    $current_setting['label-for-your-answer-is-wrong'] = 'Your answer is wrong!';
}

if (!isset($current_setting['label-for-your-answer-is-correct']))
{
    $current_setting['label-for-your-answer-is-correct'] = 'Your answer is correct!';
}

if (!isset($current_setting['label-for-sure-i-agree']))
{
    $current_setting['label-for-sure-i-agree'] = 'Sure, I agree';
}

if (!isset($current_setting['label-for-update']))
{
    $current_setting['label-for-update'] = 'Update';
}

if (!isset($current_setting['label-for-score']))
{
    $current_setting['label-for-score'] = 'Score';
}

if (!isset($current_setting['label-for-the-correct-answer-is']))
{
    $current_setting['label-for-the-correct-answer-is'] = 'The correct answer is';
}

if (!isset($current_setting['label-for-update-the-question']))
{
    $current_setting['label-for-update-the-question'] = 'Are you sure you want to update the question data, this will cause your score to be zero?';
}

if (!isset($current_setting['label-for-cancel']))
{
    $current_setting['label-for-cancel'] = 'Cancel';
}

if (!isset($current_setting['label-for-attention']))
{
    $current_setting['label-for-attention'] = 'Attention!';
}

if (!isset($current_setting['label-for-question-run-out']))
{
    $current_setting['label-for-question-run-out'] = 'Question has run out!';
}

if (!isset($current_setting['label-for-your-score']))
{
    $current_setting['label-for-your-score'] = 'Your score is:';
}

if (!isset($current_setting['label-for-repeat']))
{
    $current_setting['label-for-repeat'] = 'Repeat';
}

if (!isset($current_setting['label-for-save-score']))
{
    $current_setting['label-for-save-score'] = 'Save Score';
}

if (!isset($current_setting['label-for-submit']))
{
    $current_setting['label-for-submit'] = 'Submit';
}

if (!isset($current_setting['label-for-personal-data']))
{
    $current_setting['label-for-personal-data'] = 'Personal Data';
}

if (!isset($current_setting['label-for-name']))
{
    $current_setting['label-for-name'] = 'Name';
}

if (!isset($current_setting['label-for-note']))
{
    $current_setting['label-for-note'] = 'Note';
}


//TODO: ===============================================================
// TODO: LAYOUT --|-- FORM
$content .= '<form action="" method="post"><!-- ./form -->';
$content .= '<div class="row"><!-- row -->';
$content .= '<div class="col-md-7"><!-- col-md-7 -->';
$content .= '<div class="box box-danger">';
$content .= '<div class="box-header with-border">';
$content .= '<h3 class="box-title"><i class="fa fa-magic"></i> ' . __e('General') . '</h3>';
$content .= '<div class="pull-right box-tools">';
$content .= '<button type="button" class="btn btn-default btn-sm" data-widget="collapse" data-toggle="tooltip" title="Collapse" >';
$content .= '<i class="fa fa-minus"></i>';
$content .= '</button>';
$content .= '</div>';
$content .= '</div>';
$content .= '<div class="box-body">';
$content .= '<div class="callout callout-default">'.__e('Please complete the form below to let us know how we can help you build code:').'</div>';
 // TODO: LAYOUT --|-- FORM --|-- PAGE-TARGET
$content .= '<div class="form-group">';
$content .= '<label for="page-target">' . __e('Overwrite The Page') . '</label>';
$content .= '<select id="page-target" name="multiple-choice-question[page-target]" class="form-control" >';
$content .= '<option value="">' . __e('Page Target') . '</option>';
foreach ($static_pages as $item_page)
{
    $code_by = '';
    if (isset($item_page['code-by']))
    {
        $code_by = ' - ' . __e('by') . ': ' . $item_page['code-by'];
    }
    $selected = '';
    if ($current_setting['page-target'] == $item_page["name"])
    {
        $selected = 'selected';
    }
    $note = '';
    if (strlen($item_page["name"]) < 10)
    {
        $content .= '<option value="' . htmlentities($item_page["name"]) . ' " ' . $selected . '>- ' . htmlentities($item_page["title"]) . ' (' . htmlentities($item_page["name"]) . '' . $code_by . ')</option>';
    }


}
$content .= '</select>';
$content .= '<p class="help-block">' . __e('Select the page to be overwritten and <code>page name</code> must be less than <code>9 characters</code>') . '</p>';
$content .= '</div>';
// TODO: LAYOUT --|-- FORM --|-- PAGE-TITLE
$content .= '<div class="form-group">';
$content .= '<label for="page-title">' . __e('Page Title') . '</label>';
$content .= '<input  id="page-title" type="text" name="multiple-choice-question[page-title]" class="form-control" placeholder="My Pages"  value="' . $current_setting['page-title'] . '" required ' . $disabled . ' />';
$content .= '<p class="help-block">' . __e('The page title will be displayed') . '</p>';
$content .= '</div>';
$content .= '<hr/>';
$content .= '<div class="row"><!-- row -->';
// TODO: LAYOUT --|-- FORM --|-- PAGE-HEADER-COLOR
$content .= '<div class="col-md-6"><!-- col-md-6 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-header-color">' . __e('Header Color') . '</label>';
$content .= '<select name="multiple-choice-question[page-header-color]" class="form-control select-color" data-color="' . $current_setting['page-header-color'] . '">';
foreach ($color_names as $color_name)
{
    $selected = '';
    if ($color_name['value'] == $current_setting['page-header-color'])
    {
        $selected = 'selected';
    }
    $content .= '<option value="' . $color_name['value'] . '" ' . $selected . '>' . $color_name['label'] . '</option>';
}
$content .= '</select>';
$content .= '<p class="help-block">' . __e('Color variation from the header') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-6 -->';
// TODO: LAYOUT --|-- FORM --|-- PAGE-CONTENT-BACKGROUND
$content .= '<div class="col-md-6"><!-- col-md-6 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-background">' . __e('Background Image') . '</label>';
$content .= '<div class="input-group">';
$content .= '<input id="page-content-background" type="text" name="multiple-choice-question[page-content-background]" class="form-control" placeholder="assets/images/bg-01.png"  value="' . $current_setting['page-content-background'] . '"  ' . $disabled . ' required />';
$content .= '<span class="input-group-btn"><button type="button" data-type="file-picker" data-target="#page-content-background" class="btn btn-info btn-flat"><i class="fa fa-folder-open"></i></button></span>';
$content .= '</div>';
$content .= '<p class="help-block">' . __e('The background image of content ') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-6 -->';
$content .= '</div>';
// TODO: LAYOUT --|-- FORM --|-- BACKEND-USED --|-- SELECT
$content .= '<div class="row"><!-- row -->';

$options = array();
$options[] = array('value' => 'php-native', 'label' => '(IMAB) PHP Native Generator');
$options[] = array('value' => 'wp-plugin', 'label' => '(IMAB) WP Plugin Generator');
$options[] = array('value' => 'json-offline', 'label' => '(IMAB) JSON Editor (JSON Offline)');
$options[] = array('value' => 'json-online', 'label' => 'JSON Online');

$content .= '<div id="field-backend-used" class="col-md-6"><!-- col-md-6 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-backend-used">' . __e('Back-End Used?') . '</label>';
$content .= '<select id="page-backend-used" name="' . $prefix_addons . '[backend-used]" class="form-control" ' . $disabled . ' >';
foreach ($options as $option)
{
    $selected = '';
    if ($option['value'] == $current_setting['backend-used'])
    {
        $selected = 'selected';
    }
    $content .= '<option value="' . htmlentities($option['value']) . '" ' . $selected . '>' . htmlentities($option['label']) . '</option>';
}
$content .= '</select>';
$content .= '<p class="help-block">' . __e('What the Back-End do you want to use?') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-6 -->';


// TODO: LAYOUT --|-- FORM --|-- API-URL --|-- TEXT
$content .= '<div id="field-api-url" class="col-md-6"><!-- col-md-6 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-api-url">' . __e('API URL') . '</label>';
$content .= '<input id="page-api-url" type="text" name="' . $prefix_addons . '[api-url]" class="form-control" placeholder="https://site/restapi.php"  value="' . $current_setting['api-url'] . '"  ' . $disabled . '  />';
$content .= '<p class="help-block">' . __e('Root end point address, such as: https://site/restapi.php or https://your-wp') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-6 -->';
$content .= '</div><!-- ./row -->';

// TODO: LAYOUT --|-- FORM --|-- OPTIONS
$content .= '<div class="row"><!-- row -->';
$content .= '<div id="field-auto-menu" class="col-md-6"><!-- col-md-6 -->';
$content .= '<div class="form-group">';
$content .= '<label>' . __e('Options') . '</label>';
$content .= '<table class="table">';

// TODO: LAYOUT --|-- FORM --|-- OPTIONS --|-- MULTI-LANGUAGE
$content .= '<tr>';
if ($current_setting['multiple-language'] == true)
{
    $content .= '<td style="width:30px"><input checked="checked" class="flat-green" type="checkbox" id="page-multiple-language" name="' . $prefix_addons . '[multiple-language]" ' . $disabled . '/></td>';
} else
{
    $content .= '<td style="width:30px"><input class="flat-green" type="checkbox" id="page-multiple-language" name="' . $prefix_addons . '[multiple-language]" ' . $disabled . '/></td>';
}
$content .= '<td>' . __e('Multiple Language Support') . '</td>';
$content .= '</tr>';

// TODO: LAYOUT --|-- FORM --|-- OPTIONS --|-- SHOW ANSWERS
$content .= '<tr>';
if ($current_setting['show-answers-and-scores'] == true)
{
    $content .= '<td><input checked="checked" class="flat-red" type="checkbox" id="page-show-answers-and-scores" name="' . $prefix_addons . '[show-answers-and-scores]" ' . $disabled . '/></td>';
} else
{
    $content .= '<td><input class="flat-red" type="checkbox" id="page-show-answers-and-scores" name="' . $prefix_addons . '[show-answers-and-scores]" ' . $disabled . '/></td>';
}
$content .= '<td>' . __e('Show answers and scores') . '</td>';
$content .= '</tr>';

$content .= '<tr>';
if ($current_setting['only-one-chance'] == true)
{
    $content .= '<td><input checked="checked" class="flat-red" type="checkbox" id="page-only-one-chance" name="' . $prefix_addons . '[only-one-chance]" ' . $disabled . '/></td>';
} else
{
    $content .= '<td><input class="flat-red" type="checkbox" id="page-only-one-chance" name="' . $prefix_addons . '[only-one-chance]" ' . $disabled . '/></td>';
}
$content .= '<td>' . __e('Only one chance (Repeat button will be disabled)') . '</td>';
$content .= '</tr>';


$content .= '</table>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-6 -->';
$content .= '<div class="col-md-6"><!-- col-md-6 -->';
$content .= '<div class="form-group well" >';
$content .= '<label>' . __e('Back-End') . '</label>';
$content .= '<p>' . __e('Use the following Back-End:') . '</p>';
$content .= '<div>';
switch ($current_setting['backend-used'])
{
    case 'php-native':
        $content .= '<a target="_blank" class="btn btn-primary" href="./?p=backend-configuration&a=edit&table-name=' . $current_page_target . '"><i class="fa fa-cogs"></i> ' . __e('Configuration') . '</a>&nbsp;';
        $content .= '<a target="_blank" class="btn btn-success" href="./?p=php-native-generator"><i class="fa fa-download"></i> PHP Native Generator</a>';
        break;
    case 'wp-plugin':
        $content .= '<a target="_blank" class="btn btn-primary" href="./?p=backend-configuration&a=edit&table-name=' . $current_page_target . '"><i class="fa fa-cogs"></i> ' . __e('Configuration') . '</a>&nbsp;';
        $content .= '<a target="_blank" class="btn btn-success" href="./?p=wp-plugin-generator"><i class="fa fa-download"></i> WP Plugin Generator</a>';
        break;
    case 'json-offline':
        $content .= '<a target="_blank" class="btn btn-success" href="./?p=json-editor&table-name=' . $current_page_target . '"><i class="fa fa-download"></i> JSON Editor</a>';
        break;
    case 'json-online':
        break;
}
$content .= '</div>';
$content .= '</div><!-- ./form-group -->';
$content .= '</div><!-- ./col-md-6 -->';

$content .= '</div><!-- ./row -->';
$content .= '</div>';
$content .= '<div class="box-footer pad">';
$content .= '<input name="save-multiple-choice-question" type="submit" class="btn btn-danger btn-flat pull-left" value="' . __e('Save Changes') . '" ' . $disabled . '/>';
$content .= '</div>';
$content .= '</div>';


$content .= '<div class="box box-info">';
$content .= '<div class="box-header with-border">';
$content .= '<h3 class="box-title"><i class="fa fa-cubes"></i> ' . __e('Technical Guide') . '</h3>';
$content .= '<div class="pull-right box-tools">';
$content .= '<button type="button" class="btn btn-default btn-sm" data-widget="collapse" data-toggle="tooltip" title="Collapse">';
$content .= '<i class="fa fa-minus"></i>';
$content .= '</button>';
$content .= '</div>';
$content .= '</div>';
$content .= '<div class="box-body">';

$content .= '<h4>' . __e('Backend characteristics used:') . '</h4>';
$content .= '<table class="table table-striped">';
$content .= '<thead>';
$content .= '<tr>';
$content .= '<th>' . __e('Backend Used?') . '</th>';
$content .= '<th>' . __e('Random Question') . '</th>';
$content .= '<th>' . __e('Score Record') . '</th>';
$content .= '</tr>';
$content .= '</thead>';

$content .= '<tbody>';
$content .= '<tr>';
$content .= '<td>' . __e('(IMAB) PHP Native Generator') . '</td>';
$content .= '<td>' . __e('Yes') . '</td>';
$content .= '<td>' . __e('Yes') . '</td>';
$content .= '</tr>';
$content .= '<tr>';
$content .= '<td>' . __e('(IMAB) WP Plugin Generator') . '</td>';
$content .= '<td>' . __e('Yes') . '</td>';
$content .= '<td>' . __e('Yes') . '</td>';
$content .= '</tr>';
$content .= '<tr>';
$content .= '<td>' . __e('(IMAB) JSON Editor (Offline App)') . '</td>';
$content .= '<td>' . __e('No') . '</td>';
$content .= '<td>' . __e('No') . '</td>';
$content .= '</tr>';
$content .= '<tr>';
$content .= '<td>' . __e('JSON Online') . '</td>';
$content .= '<td>' . __e('No') . '</td>';
$content .= '<td>' . __e('No') . '</td>';
$content .= '</tr>';
$content .= '</tbody>';
$content .= '</table>';

$content .= '<hr/>';
$content .= '<h4>' . __e('URL API') . '</h4>';
$content .= '<table class="table table-striped">';
$content .= '<thead>';
$content .= '<tr>';
$content .= '<th>' . __e('Backend Used?') . '</th>';
$content .= '<th>' . __e('URL API') . '</th>';
$content .= '</tr>';
$content .= '</thead>';

$content .= '<tbody>';
$content .= '<tr>';
$content .= '<td>' . __e('(IMAB) PHP Native Generator') . '</td>';
$content .= '<td><code>https://your-site.com/restapi.php</code><br/><code>https://ihsana.com/quiz/restapi.php</code></td>';
$content .= '</tr>';
$content .= '<tr>';
$content .= '<td>' . __e('(IMAB) WP Plugin Generator') . '</td>';
$content .= '<td><code>https://your-site.com/</code><br/><code>https://ihsana.com/my-wp/</code></td>';
$content .= '</tr>';
$content .= '<tr>';
$content .= '<td>' . __e('(IMAB) JSON Editor (Offline App)') . '</td>';
$content .= '<td><code>blank</code></td>';
$content .= '</tr>';
$content .= '<tr>';
$content .= '<td>' . __e('JSON Online') . '</td>';
$content .= '<td><code>https://your-site.com/quiz/question.json</code><br/><code>https://ihsana.com/quiz/db.json</code></td>';
$content .= '</tr>';
$content .= '</tbody>';
$content .= '</table>';


$content .= '</div><!-- ./box-body -->';
$content .= '</div><!-- ./box -->';


$content .= '</div><!-- ./col-md-7 -->';
$content .= '<div class="col-md-5"><!-- col-md-5 -->';
$content .= '<div class="box box-warning">';
$content .= '<div class="box-header with-border">';
$content .= '<h3 class="box-title"><i class="fa fa-cubes"></i> ' . __e('Latest Used') . '</h3>';
$content .= '<div class="pull-right box-tools">';
$content .= '<button type="button" class="btn btn-default btn-sm" data-widget="collapse" data-toggle="tooltip" title="Collapse">';
$content .= '<i class="fa fa-minus"></i>';
$content .= '</button>';
$content .= '</div>';
$content .= '</div>';
$content .= '<div class="box-body">';
$content .= '<div class="callout callout-default">' . __e('Some settings that you have made:') . '</div>';
$content .= '<div class="table-responsive">';
$content .= '<table class="table table-striped" id="latest-used">';
$content .= '<thead>';
$content .= '<tr>';
$content .= '<th>#</th>';
$content .= '<th>' . __e('Target') . '</th>';
$content .= '<th>' . __e('Title') . '</th>';
$content .= '<th></th>';
$content .= '</tr>';
$content .= '</thead>';
$content .= '<tbody>';
$modal_dialog = null;
if (count($addons_settings) >= 1)
{
    $no = 1;
    foreach ($addons_settings as $pageList)
    {
        $content .= '<tr>';
        $content .= '<td>' . $no . '</td>';
        $content .= '<td><a target="_blank" href="./?p=pages&amp;a=edit&amp;page-name=' . $pageList['page-target'] . '">' . $pageList['page-target'] . '</a></td>';
        $content .= '<td>' . $pageList['page-title'] . '</td>';
        $content .= '<td>';
        $content .= '<a href="./?p=addons&amp;addons=multiple-choice-question&amp;page-target=' . $pageList['page-target'] . '&amp;a=edit#!_" class="btn btn-xs btn-flat btn-success"><i class="fa fa-pencil-square-o"></i> ' . __e('Edit') . '</a>&nbsp;';
        $content .= '<a href="#!_./?p=addons&amp;addons=multiple-choice-question&amp;page-target=' . $pageList['page-target'] . '&amp;a=delete#!_" data-toggle="modal" data-target="#trash-dialog-' . $no . '" class="btn btn-xs btn-flat btn-danger"><i class="fa fa-trash"></i> ' . __e('Delete') . '</a>';
        $content .= '</td>';
        $content .= '</tr>';
        $modal_dialog .= '<div class="modal fade modal-default" id="trash-dialog-' . $no . '" tabindex="-1" role="dialog" aria-labelledby="trash-dialog-' . $no . '" aria-hidden="true">';
        $modal_dialog .= '<div class="modal-dialog">';
        $modal_dialog .= '<div class="modal-content">';
        $modal_dialog .= '<div class="modal-header">';
        $modal_dialog .= '<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>';
        $modal_dialog .= '<h4 class="modal-title" id="delete-app-label">' . __e('Delete Adds-ons Settings') . '</h4>';
        $modal_dialog .= '</div><!-- ./modal-header -->';
        $modal_dialog .= '<div class="modal-body">';
        $modal_dialog .= '<p>' . __e('Deleting this add-ons setting will not delete the page code that you have created. Are you sure want to delete this settings?') . '</p>';
        $modal_dialog .= '<div class="row">';
        $modal_dialog .= '<div class="col-md-3">';
        $modal_dialog .= '<div class="icon icon-confirm text-center"><i class="fa fa-5x fa-cogs"></i></div>';
        $modal_dialog .= '</div>';
        $modal_dialog .= '<div class="col-md-9 text-left">';
        $modal_dialog .= '<table class="table-confirm">';
        $modal_dialog .= '<tr>';
        $modal_dialog .= '<td>' . __e('Page Target') . '</td>';
        $modal_dialog .= '<td>: <strong>' . $pageList['page-target'] . '</strong></td>';
        $modal_dialog .= '</tr>';
        $modal_dialog .= '<tr>';
        $modal_dialog .= '<td>' . __e('Page Title') . '</td>';
        $modal_dialog .= '<td>: <strong>' . $pageList['page-title'] . '</strong></td>';
        $modal_dialog .= '</tr>';
        $modal_dialog .= '</table>';
        $modal_dialog .= '</div>';
        $modal_dialog .= '</div>';
        $modal_dialog .= '</div><!-- ./modal-body -->';
        $modal_dialog .= '<div class="modal-footer">';
        $modal_dialog .= '<a href="./?p=addons&amp;addons=multiple-choice-question&amp;page-target=' . $pageList['page-target'] . '&amp;a=delete" class="btn btn-danger">' . __e('Yes') . '</a>&nbsp;';
        $modal_dialog .= '<button type="button" data-dismiss="modal" class="btn">' . __e('Cancel') . '</button>';
        $modal_dialog .= '</div>';
        $modal_dialog .= '</div><!-- ./modal-content -->';
        $modal_dialog .= '</div><!-- ./modal-dialog -->';
        $modal_dialog .= '</div><!-- ./modal -->';
        $no++;
    }
} else
{
    $content .= '<tr>';
    $content .= '<td>&nbsp;</td>';
    $content .= '<td>' . __e('no pages') . '</td>';
    $content .= '<td></td>';
    $content .= '<td></td>';
    $content .= '</tr>';
}
$content .= '</tbody>';
$content .= '</table>';
$content .= '</div><!-- ./table-responsive -->';
$content .= '<div class="trash-dialog"><!-- trash-dialog -->';
$content .= $modal_dialog;
$content .= '</div><!-- ./trash-dialog -->';
$content .= '</div><!-- ./box-body -->';
$content .= '</div><!-- ./box -->';

//TODO: ===============================================================
$content .= '<div class="box box-warning">';
$content .= '<div class="box-header with-border">';
$content .= '<h3 class="box-title"><i class="fa fa-cubes"></i> ' . __e('Labels') . '</h3>';
$content .= '<div class="pull-right box-tools">';
$content .= '<button type="button" class="btn btn-default btn-sm" data-widget="collapse" data-toggle="tooltip" title="Collapse">';
$content .= '<i class="fa fa-minus"></i>';
$content .= '</button>';
$content .= '</div>';
$content .= '</div>';
$content .= '<div class="box-body">';

// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-PLEASE-WAIT --|-- TEXT
$content .= '<div class="row"><!-- row -->';
$content .= '<div id="field-label-for-please-wait" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-please-wait">' . __e('Label for `Please wait...!`') . '</label>';
$content .= '<input id="page-label-for-please-wait" type="text" name="' . $prefix_addons . '[label-for-please-wait]" class="form-control" placeholder="Please wait...!"  value="' . $current_setting['label-for-please-wait'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Please wait...!`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';
// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-OK --|-- TEXT
$content .= '<div id="field-label-for-ok" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-ok">' . __e('Label for `OK`') . '</label>';
$content .= '<input id="page-label-for-ok" type="text" name="' . $prefix_addons . '[label-for-ok]" class="form-control" placeholder="OK"  value="' . $current_setting['label-for-ok'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `OK`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';
// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-CONNECTION-LOST --|-- TEXT
$content .= '<div id="field-label-for-connection-lost" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-connection-lost">' . __e('Label for `Connection lost`') . '</label>';
$content .= '<input id="page-label-for-connection-lost" type="text" name="' . $prefix_addons . '[label-for-connection-lost]" class="form-control" placeholder="Connection lost, please check your connection!"  value="' . $current_setting['label-for-connection-lost'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Connection lost, please check your connection!`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';
$content .= '</div><!-- ./row -->';
// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-QUESTION --|-- TEXT
$content .= '<div class="row"><!-- row -->';
$content .= '<div id="field-label-for-question" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-question">' . __e('Label for `Question`') . '</label>';
$content .= '<input id="page-label-for-question" type="text" name="' . $prefix_addons . '[label-for-question]" class="form-control" placeholder="Question"  value="' . $current_setting['label-for-question'] . '"  ' . $disabled . '  />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Question`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';
// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-YOUR-CHOICE --|-- TEXT
$content .= '<div id="field-label-for-your-choice" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-your-choice">' . __e('Label for `Your choice!`') . '</label>';
$content .= '<input id="page-label-for-your-choice" type="text" name="' . $prefix_addons . '[label-for-your-choice]" class="form-control" placeholder="Your choice!"  value="' . $current_setting['label-for-your-choice'] . '"  ' . $disabled . '  />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Your choice!`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';


// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-YOUR-ANSWER-IS-WRONG --|-- TEXT

$content .= '<div id="field-label-for-your-answer-is-wrong" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-your-answer-is-wrong">' . __e('Label for `Your answer is wrong!`') . '</label>';
$content .= '<input id="page-label-for-your-answer-is-wrong" type="text" name="' . $prefix_addons . '[label-for-your-answer-is-wrong]" class="form-control" placeholder="Your answer is wrong!"  value="' . $current_setting['label-for-your-answer-is-wrong'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Your answer is wrong!`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';
$content .= '</div><!-- ./row -->';

// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-YOUR-ANSWER-IS-CORRECT --|-- TEXT
$content .= '<div class="row"><!-- row -->';
$content .= '<div id="field-label-for-your-answer-is-correct" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-your-answer-is-correct">' . __e('Label for `Your answer is correct!`') . '</label>';
$content .= '<input id="page-label-for-your-answer-is-correct" type="text" name="' . $prefix_addons . '[label-for-your-answer-is-correct]" class="form-control" placeholder="Your answer is correct!"  value="' . $current_setting['label-for-your-answer-is-correct'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Your answer is correct!`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';

// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-SURE-I-AGREE --|-- TEXT

$content .= '<div id="field-label-for-sure-i-agree" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-sure-i-agree">' . __e('Label for `Sure, I agree`') . '</label>';
$content .= '<input id="page-label-for-sure-i-agree" type="text" name="' . $prefix_addons . '[label-for-sure-i-agree]" class="form-control" placeholder="Sure, I agree"  value="' . $current_setting['label-for-sure-i-agree'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Sure, I agree`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';


// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-UPDATE --|-- TEXT

$content .= '<div id="field-label-for-update" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-update">' . __e('Label for `Update`') . '</label>';
$content .= '<input id="page-label-for-update" type="text" name="' . $prefix_addons . '[label-for-update]" class="form-control" placeholder="Update"  value="' . $current_setting['label-for-update'] . '"  ' . $disabled . '  />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Update`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';
$content .= '</div><!-- ./row -->';

// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-SCORE --|-- TEXT
$content .= '<div class="row"><!-- row -->';
$content .= '<div id="field-label-for-score" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-score">' . __e('Label for `Score`') . '</label>';
$content .= '<input id="page-label-for-score" type="text" name="' . $prefix_addons . '[label-for-score]" class="form-control" placeholder="Score"  value="' . $current_setting['label-for-score'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Score`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';


// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-THE-CORRECT-ANSWER-IS --|-- TEXT

$content .= '<div id="field-label-for-the-correct-answer-is" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-the-correct-answer-is">' . __e('Label for `The correct answer is`') . '</label>';
$content .= '<input id="page-label-for-the-correct-answer-is" type="text" name="' . $prefix_addons . '[label-for-the-correct-answer-is]" class="form-control" placeholder="The correct answer is"  value="' . $current_setting['label-for-the-correct-answer-is'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `The correct answer is`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';


// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-UPDATE-THE-QUESTION --|-- TEXT

$content .= '<div id="field-label-for-update-the-question" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-update-the-question">' . __e('Label for `Update the question`') . '</label>';
$content .= '<input id="page-label-for-update-the-question" type="text" name="' . $prefix_addons . '[label-for-update-the-question]" class="form-control" placeholder="Are you sure you want to update the question data?"  value="' . $current_setting['label-for-update-the-question'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Are you sure you want to update the question data? `') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';
$content .= '</div><!-- ./row -->';

// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-CANCEL --|-- TEXT
$content .= '<div class="row"><!-- row -->';
$content .= '<div id="field-label-for-cancel" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-cancel">' . __e('Label for `Cancel`') . '</label>';
$content .= '<input id="page-label-for-cancel" type="text" name="' . $prefix_addons . '[label-for-cancel]" class="form-control" placeholder="Cancel"  value="' . $current_setting['label-for-cancel'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Cancel`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';


// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-ATTENTION --|-- TEXT

$content .= '<div id="field-label-for-attention" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-attention">' . __e('Label for `Attention!`') . '</label>';
$content .= '<input id="page-label-for-attention" type="text" name="' . $prefix_addons . '[label-for-attention]" class="form-control" placeholder="Attention!"  value="' . $current_setting['label-for-attention'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Attention!`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';


// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-QUESTION-RUN-OUT --|-- TEXT

$content .= '<div id="field-label-for-question-run-out" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-question-run-out">' . __e('Label for `Question has run out`') . '</label>';
$content .= '<input id="page-label-for-question-run-out" type="text" name="' . $prefix_addons . '[label-for-question-run-out]" class="form-control" placeholder="Question has run out"  value="' . $current_setting['label-for-question-run-out'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Question has run out!') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';
$content .= '</div><!-- ./row -->';

// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-YOUR-SCORE --|-- TEXT
$content .= '<div class="row"><!-- row -->';
$content .= '<div id="field-label-for-your-score" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-your-score">' . __e('Label for `Your score is`') . '</label>';
$content .= '<input id="page-label-for-your-score" type="text" name="' . $prefix_addons . '[label-for-your-score]" class="form-control" placeholder="Your score is"  value="' . $current_setting['label-for-your-score'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Your score is`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';


// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-REPEAT --|-- TEXT

$content .= '<div id="field-label-for-repeat" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-repeat">' . __e('Label for `Repeat`') . '</label>';
$content .= '<input id="page-label-for-repeat" type="text" name="' . $prefix_addons . '[label-for-repeat]" class="form-control" placeholder="Repeat"  value="' . $current_setting['label-for-repeat'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Repeat`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';


// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-SAVE-SCORE --|-- TEXT

$content .= '<div id="field-label-for-save-score" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-save-score">' . __e('Label for `Save Score`') . '</label>';
$content .= '<input id="page-label-for-save-score" type="text" name="' . $prefix_addons . '[label-for-save-score]" class="form-control" placeholder="Label for `Save Score`"  value="' . $current_setting['label-for-save-score'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Save Score`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';
$content .= '</div><!-- ./row -->';


// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-SUBMIT --|-- TEXT
$content .= '<div class="row"><!-- row -->';
$content .= '<div id="field-label-for-submit" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-submit">' . __e('Label for `Submit`') . '</label>';
$content .= '<input id="page-label-for-submit" type="text" name="' . $prefix_addons . '[label-for-submit]" class="form-control" placeholder="Submit"  value="' . $current_setting['label-for-submit'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Submit`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';


// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-PERSONAL-DATA --|-- TEXT

$content .= '<div id="field-label-for-personal-data" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-personal-data">' . __e('Label for `Personal Data`') . '</label>';
$content .= '<input id="page-label-for-personal-data" type="text" name="' . $prefix_addons . '[label-for-personal-data]" class="form-control" placeholder="Personal Data"  value="' . $current_setting['label-for-personal-data'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Personal Data`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';


// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-NAME --|-- TEXT

$content .= '<div id="field-label-for-name" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-name">' . __e('Label for `Name`') . '</label>';
$content .= '<input id="page-label-for-name" type="text" name="' . $prefix_addons . '[label-for-name]" class="form-control" placeholder="Name"  value="' . $current_setting['label-for-name'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Name`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';
$content .= '</div><!-- ./row -->';

// TODO: LAYOUT --|-- FORM --|-- LABEL-FOR-NOTE --|-- TEXT
$content .= '<div class="row"><!-- row -->';
$content .= '<div id="field-label-for-note" class="col-md-4"><!-- col-md-4 -->';
$content .= '<div class="form-group">';
$content .= '<label for="page-label-for-note">' . __e('Label for `Note`') . '</label>';
$content .= '<input id="page-label-for-note" type="text" name="' . $prefix_addons . '[label-for-note]" class="form-control" placeholder="Note"  value="' . $current_setting['label-for-note'] . '"  ' . $disabled . ' required />';
$content .= '<p class="help-block">' . __e('Write the label text for the `Note`') . '</p>';
$content .= '</div>';
$content .= '</div><!-- ./col-md-4 -->';
$content .= '</div><!-- ./row -->';


//-----------------------------------------------------
$content .= '</div><!-- ./box-body -->';
$content .= '<div class="box-footer pad">';
$content .= '<input name="save-multiple-choice-question" type="submit" class="btn btn-warning btn-flat pull-left" value="' . __e('Save Changes') . '" ' . $disabled . '/>';
$content .= '</div>';
$content .= '</div><!-- ./box -->';


$content .= '</div><!-- ./col-md-5 -->';
$content .= '</div><!-- ./row -->';
$content .= '</form><!-- ./form -->';
//TODO: ===============================================================
// TODO: JS
$page_js .= '$("#page-target").on("change",function(){return window.location="?p=addons&addons=multiple-choice-question&page-target="+$("#page-target").val(),!1});';
